"use strict";

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importStar(require("react"));

var with_default_props_1 = require("../../utils/with-default-props");

var classnames_1 = __importDefault(require("classnames"));

var popup_1 = __importDefault(require("../popup"));

var button_1 = __importDefault(require("../button"));

var attach_properties_to_component_1 = require("../../utils/attach-properties-to-component");

var render_to_body_1 = require("../../utils/render-to-body");

var classPrefix = "am-action-sheet";
var defaultProps = {
  visible: false,
  actions: [],
  cancelText: '',
  closeOnSelect: false,
  closeOnMaskClick: true
};
var ActionSheet = with_default_props_1.withDefaultProps(defaultProps)(function (props) {
  return react_1["default"].createElement(popup_1["default"], {
    visible: props.visible,
    onMaskClick: function onMaskClick() {
      props.onMaskClick == null ? void 0 : props.onMaskClick();

      if (props.closeOnMaskClick) {
        props.onClose == null ? void 0 : props.onClose();
      }
    },
    afterClose: props.afterClose,
    className: classPrefix + "-popup",
    getContainer: props.getContainer
  }, react_1["default"].createElement("div", {
    className: classnames_1["default"](classPrefix, props.className)
  }, props.extra && react_1["default"].createElement("div", {
    className: classPrefix + "-extra"
  }, props.extra), react_1["default"].createElement("div", {
    className: classPrefix + "-button-list"
  }, props.actions.map(function (action, index) {
    var _classnames_1$default;

    return react_1["default"].createElement("div", {
      key: action.key,
      className: classPrefix + "-button-item-wrapper"
    }, react_1["default"].createElement(button_1["default"], {
      block: true,
      fill: 'none',
      disabled: action.disabled,
      onClick: function onClick() {
        action.onClick == null ? void 0 : action.onClick();
        props.onSelect == null ? void 0 : props.onSelect(action, index);

        if (props.closeOnSelect) {
          props.onClose == null ? void 0 : props.onClose();
        }
      },
      className: classnames_1["default"](classPrefix + "-button-item", (_classnames_1$default = {}, _classnames_1$default[classPrefix + "-button-item-danger"] = action.danger, _classnames_1$default))
    }, react_1["default"].createElement("div", {
      className: classPrefix + "-button-item-name"
    }, action.text), action.description && react_1["default"].createElement("div", {
      className: classPrefix + "-button-item-description"
    }, action.description)));
  })), props.cancelText && react_1["default"].createElement("div", {
    className: classPrefix + "-cancel"
  }, react_1["default"].createElement("div", {
    className: classPrefix + "-button-item-wrapper"
  }, react_1["default"].createElement(button_1["default"], {
    block: true,
    fill: 'none',
    className: classPrefix + "-button-item",
    onClick: function onClick() {
      props.onClose == null ? void 0 : props.onClose();
    }
  }, react_1["default"].createElement("div", {
    className: classPrefix + "-button-item-name"
  }, props.cancelText))))));
});

function showActionSheet(props) {
  var Wrapper = react_1.forwardRef(function (_, ref) {
    var _react_1$useState = react_1.useState(false),
        visible = _react_1$useState[0],
        setVisible = _react_1$useState[1];

    react_1.useEffect(function () {
      setVisible(true);
    }, []);
    react_1.useImperativeHandle(ref, function () {
      return {
        close: function close() {
          setVisible(false);
        }
      };
    });
    return react_1["default"].createElement(ActionSheet, Object.assign({}, props, {
      visible: visible,
      onClose: function onClose() {
        props.onClose == null ? void 0 : props.onClose();
        setVisible(false);
      },
      afterClose: function afterClose() {
        props.afterClose == null ? void 0 : props.afterClose();
        unmount();
      }
    }));
  });
  var ref = react_1.createRef();
  var unmount = render_to_body_1.renderToBody(react_1["default"].createElement(Wrapper, {
    ref: ref
  }));
  return {
    close: function close() {
      var _ref$current;

      (_ref$current = ref.current) == null ? void 0 : _ref$current.close();
    }
  };
}

exports["default"] = attach_properties_to_component_1.attachPropertiesToComponent(ActionSheet, {
  show: showActionSheet
});