"use strict";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var classnames_1 = __importDefault(require("classnames"));

var react_1 = __importDefault(require("react"));

var convert_px_1 = require("../../utils/convert-px");

var with_default_props_1 = require("../../utils/with-default-props");

var classPrefix = "am-badge";
var Badge = with_default_props_1.withDefaultProps({
  color: '#FF411C',
  offset: [0, 0]
})(function (props) {
  var _classnames_1$default;

  var content = props.content,
      color = props.color,
      offset = props.offset,
      children = props.children;
  var badgeStyle = children ? {
    marginTop: convert_px_1.convertPx(offset[0]) + "px",
    right: -convert_px_1.convertPx(offset[1]) + "px",
    backgroundColor: color
  } : {
    backgroundColor: color
  };
  var badgeCls = classnames_1["default"](classPrefix, (_classnames_1$default = {}, _classnames_1$default[classPrefix + "-fixed"] = !!children, _classnames_1$default[classPrefix + "-dot"] = !content, _classnames_1$default));
  return children ? react_1["default"].createElement("div", {
    className: classnames_1["default"](classPrefix + "-wrap", props.className),
    style: props.style
  }, children, react_1["default"].createElement("div", {
    className: badgeCls,
    style: badgeStyle
  }, content)) : react_1["default"].createElement("div", {
    className: classnames_1["default"](badgeCls, props.className),
    style: _extends({}, badgeStyle, props.style)
  }, content);
});
exports["default"] = Badge;