"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var classPrefix = "am-card";

var Card = function Card(props) {
  var renderHeader = function renderHeader() {
    if (!(props.title || props.extra)) {
      return null;
    }

    return react_1["default"].createElement("div", {
      className: classnames_1["default"](classPrefix + "-header"),
      onClick: props.onHeaderClick
    }, react_1["default"].createElement("div", {
      className: classPrefix + "-header-title"
    }, props.title), props.extra);
  };

  var renderBody = function renderBody() {
    if (!props.children) {
      return null;
    }

    return react_1["default"].createElement("div", {
      className: classPrefix + "-body",
      onClick: props.onBodyClick
    }, props.children);
  };

  return react_1["default"].createElement("div", {
    className: classnames_1["default"](classPrefix, props.className),
    onClick: props.onClick,
    style: props.style
  }, renderHeader(), renderBody());
};

exports["default"] = Card;