"use strict";

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var ahooks_1 = require("ahooks");

var classnames_1 = __importDefault(require("classnames"));

var react_1 = __importStar(require("react"));

var attach_properties_to_component_1 = require("../../utils/attach-properties-to-component");

var tree_1 = require("../../utils/tree");

var with_default_props_1 = require("../../utils/with-default-props");

var multiple_1 = __importDefault(require("./multiple"));

var classPrefix = "am-cascader";
var Cascader = with_default_props_1.withDefaultProps({
  options: [],
  fieldNames: {}
})(function (props) {
  var labelName = props.fieldNames.label || 'label';
  var valueName = props.fieldNames.value || 'value';
  var childrenName = props.fieldNames.children || 'children';

  var _ahooks_1$useControll = ahooks_1.useControllableValue(props, {
    defaultValue: []
  }),
      value = _ahooks_1$useControll[0],
      setValue = _ahooks_1$useControll[1];

  var _react_1$useMemo = react_1.useMemo(function () {
    var deep = tree_1.getTreeDeep(props.options, childrenName);
    var optionsMap = new Map();
    var optionsParentMap = new Map();

    function traverse(current, children) {
      children.forEach(function (item) {
        optionsParentMap.set(item[valueName], current);
        optionsMap.set(item[valueName], item);

        if (item[childrenName]) {
          traverse(item, item[childrenName]);
        }
      });
    }

    traverse(undefined, props.options);
    return [deep, optionsMap, optionsParentMap];
  }, [props.options]),
      deep = _react_1$useMemo[0],
      optionsMap = _react_1$useMemo[1],
      optionsParentMap = _react_1$useMemo[2];

  var onItemSelect = function onItemSelect(node) {
    // 找到父级节点
    var parentNodes = [];
    var current = node;

    while (current) {
      parentNodes.unshift(current);
      var next = optionsParentMap.get(current[valueName]);
      current = next;
    }

    var values = parentNodes.map(function (i) {
      return i[valueName];
    });
    setValue(values, parentNodes);
  };

  var renderItems = function renderItems(columnOptions, index) {
    if (columnOptions === void 0) {
      columnOptions = [];
    }

    return columnOptions.map(function (item) {
      var _classnames_1$default;

      var isActive = item[valueName] === value[index];
      return react_1["default"].createElement("div", {
        key: item[valueName],
        className: classnames_1["default"](classPrefix + "-item", (_classnames_1$default = {}, _classnames_1$default[classPrefix + "-item-active"] = isActive, _classnames_1$default)),
        onClick: function onClick() {
          if (!isActive) {
            onItemSelect(item);
          }
        }
      }, item[labelName]);
    });
  };

  var renderColumns = function renderColumns() {
    var columns = [];

    for (var i = 0; i < deep; i++) {
      var _optionsMap$get;

      var width = 100 / deep + "%"; // 两列的第一列宽度为 33.33，两列的第二列为 66.67%

      if (deep === 2 && i === 0) {
        width = "33.33%";
      }

      if (deep === 2 && i === 1) {
        width = "66.67%";
      }

      var column = react_1["default"].createElement("div", {
        key: i,
        className: classnames_1["default"](classPrefix + "-column"),
        style: {
          width: width
        }
      }, renderItems(i === 0 ? props.options : (_optionsMap$get = optionsMap.get(value[i - 1])) == null ? void 0 : _optionsMap$get[childrenName], i));
      columns.push(column);
    }

    return columns;
  };

  return react_1["default"].createElement("div", {
    className: classnames_1["default"](classPrefix, props.className),
    style: props.style
  }, renderColumns());
});
exports["default"] = attach_properties_to_component_1.attachPropertiesToComponent(Cascader, {
  Multiple: multiple_1["default"]
});