"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Group = void 0;

var react_1 = __importDefault(require("react"));

var ahooks_1 = require("ahooks");

var with_default_props_1 = require("../../utils/with-default-props");

var group_context_1 = require("./group-context");

var defaultProps = {
  disabled: false
};
exports.Group = with_default_props_1.withDefaultProps(defaultProps)(function (props) {
  var _ahooks_1$useControll = ahooks_1.useControllableValue(props, {
    defaultValue: []
  }),
      value = _ahooks_1$useControll[0],
      setValue = _ahooks_1$useControll[1];

  return react_1["default"].createElement(group_context_1.CheckboxGroupContext.Provider // TODO: 性能优化
  , {
    // TODO: 性能优化
    value: {
      value: value,
      disabled: props.disabled,
      check: function check(v) {
        setValue([].concat(value, [v]));
      },
      uncheck: function uncheck(v) {
        setValue(value.filter(function (item) {
          return item !== v;
        }));
      }
    }
  }, props.children);
});