"use strict";

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importStar(require("react"));

var ahooks_1 = require("ahooks");

var attach_properties_to_component_1 = require("../../utils/attach-properties-to-component");

var list_1 = __importDefault(require("../list"));

var icons_1 = require("@ant-design/icons");

var classnames_1 = __importDefault(require("classnames"));

var use_initialized_1 = require("../../utils/use-initialized");

var web_1 = require("@react-spring/web");

var CollapsePanel = function CollapsePanel() {
  return null;
};

var CollapsePanelContent = function CollapsePanelContent(props) {
  var visible = props.visible;
  var innerRef = react_1.useRef(null);
  var initialized = use_initialized_1.useInitialized(visible || props.forceRender);

  var _web_1$useSpring = web_1.useSpring(function () {
    return {
      from: {
        height: visible ? 'auto' : 0
      }
    };
  }),
      style = _web_1$useSpring[0],
      api = _web_1$useSpring[1];

  react_1.useEffect(function () {
    if (visible) {
      var inner = innerRef.current;
      if (!inner) return;
      api.start({
        height: inner.offsetHeight
      });
    } else {
      api.start({
        height: 0
      });
    }
  }, [visible]);
  return initialized ? react_1["default"].createElement(web_1.animated.div, {
    className: 'am-collapse-panel-content',
    style: style
  }, react_1["default"].createElement("div", {
    className: 'am-collapse-panel-content-inner',
    ref: innerRef
  }, react_1["default"].createElement(list_1["default"].Item, null, props.children))) : null;
};

var Collapse = function Collapse(props) {
  var panels = [];
  react_1["default"].Children.forEach(props.children, function (child) {
    if (!react_1["default"].isValidElement(child)) return;
    var key = child.key;
    if (typeof key !== 'string') return;
    panels.push(child);
  });

  var _ahooks_1$useControll = ahooks_1.useControllableValue(props, {
    valuePropName: 'activeKey',
    defaultValuePropName: 'defaultActiveKey',
    defaultValue: [],
    trigger: 'onChange'
  }),
      activeKey = _ahooks_1$useControll[0],
      setActiveKey = _ahooks_1$useControll[1];

  var activeKeyList = activeKey === null ? [] : Array.isArray(activeKey) ? activeKey : [activeKey];
  return react_1["default"].createElement("div", {
    className: classnames_1["default"]('am-collapse', props.className),
    style: props.style
  }, react_1["default"].createElement(list_1["default"], null, panels.map(function (panel) {
    var key = panel.key;
    var active = activeKeyList.includes(key);

    function handleClick() {
      if (props.accordion) {
        if (active) {
          setActiveKey(null);
        } else {
          setActiveKey(key);
        }
      } else {
        if (active) {
          setActiveKey(activeKeyList.filter(function (v) {
            return v !== key;
          }));
        } else {
          setActiveKey([].concat(activeKeyList, [key]));
        }
      }
    }

    return react_1["default"].createElement(react_1["default"].Fragment, {
      key: key
    }, react_1["default"].createElement(list_1["default"].Item, {
      className: classnames_1["default"]('am-collapse-panel-header', {
        'am-collapse-panel-header-disabled': panel.props.disabled
      }),
      onClick: panel.props.disabled ? undefined : handleClick,
      arrow: react_1["default"].createElement("div", {
        className: classnames_1["default"]('am-collapse-arrow', {
          'am-collapse-arrow-active': active
        })
      }, react_1["default"].createElement(icons_1.RightOutlined, null))
    }, panel.props.title), react_1["default"].createElement(CollapsePanelContent, {
      visible: active,
      forceRender: !!panel.props.forceRender
    }, panel.props.children));
  })));
};

exports["default"] = attach_properties_to_component_1.attachPropertiesToComponent(Collapse, {
  Panel: CollapsePanel
});