"use strict";

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importStar(require("react"));

var picker_1 = __importDefault(require("../picker"));

var ahooks_1 = require("ahooks");

var dayjs_1 = __importDefault(require("dayjs"));

var generate_int_array_1 = require("../../utils/generate-int-array");

var with_default_props_1 = require("../../utils/with-default-props");

var attach_properties_to_component_1 = require("../../utils/attach-properties-to-component");

var render_to_body_1 = require("../../utils/render-to-body");

var thisYear = new Date().getFullYear();
var defaultProps = {
  min: new Date(new Date().setFullYear(thisYear - 10)),
  max: new Date(new Date().setFullYear(thisYear + 10))
};
var DatePicker = with_default_props_1.withDefaultProps(defaultProps)(function (props) {
  var _ahooks_1$useControll = ahooks_1.useControllableValue(props, {
    trigger: 'onConfirm',
    defaultValue: null
  }),
      value = _ahooks_1$useControll[0],
      setValue = _ahooks_1$useControll[1];

  function columns(selected) {
    var years = [];
    var minYear = props.min.getFullYear();
    var minMonth = props.min.getMonth() + 1;
    var minDate = props.min.getDate();
    var maxYear = props.max.getFullYear();
    var maxMonth = props.max.getMonth() + 1;
    var maxDate = props.max.getDate();
    var firstDayInSelectedMonth = dayjs_1["default"](convertStringArrayToDate([selected[0], selected[1], '1']));
    var selectedYear = firstDayInSelectedMonth.year();
    var selectedMonth = firstDayInSelectedMonth.month() + 1;

    for (var i = minYear; i <= maxYear; i++) {
      years.push(i.toString());
    }

    var months = generate_int_array_1.generateIntArray(1, 12).filter(function (v) {
      if (selectedYear === minYear && v < minMonth) {
        return false;
      }

      if (selectedYear === maxYear && v > maxMonth) {
        return false;
      }

      return true;
    }).map(function (v) {
      return v.toString();
    });
    var days = [];
    days = generate_int_array_1.generateIntArray(1, firstDayInSelectedMonth.daysInMonth()).filter(function (v) {
      if (selectedYear === minYear && selectedMonth === minMonth && v < minDate) {
        return false;
      }

      if (selectedYear === maxYear && selectedMonth === maxMonth && v > maxDate) {
        return false;
      }

      return true;
    }).map(function (v) {
      return v.toString();
    });
    return [years, months, days];
  }

  var pickerValue = react_1.useMemo(function () {
    return convertDateToStringArray(value);
  }, [value]);
  var onConfirm = react_1.useCallback(function (val) {
    setValue(convertStringArrayToDate(val));
  }, [setValue]);
  var onSelect = react_1.useCallback(function (val) {
    props.onSelect == null ? void 0 : props.onSelect(convertStringArrayToDate(val));
  }, [props.onSelect]);
  return react_1["default"].createElement(picker_1["default"], {
    columns: columns,
    value: pickerValue,
    onCancel: props.onCancel,
    onClose: props.onClose,
    visible: props.visible,
    confirmText: props.confirmText,
    cancelText: props.cancelText,
    onConfirm: onConfirm,
    onSelect: onSelect,
    getContainer: props.getContainer,
    afterShow: props.afterShow,
    afterClose: props.afterClose
  }, function (items) {
    return props.children == null ? void 0 : props.children(convertStringArrayToDate(items.map(function (item) {
      return item == null ? void 0 : item.value;
    })));
  });
});

function convertDateToStringArray(date) {
  if (!date) return [];
  return [date.getFullYear().toString(), (date.getMonth() + 1).toString(), date.getDate().toString()];
}

function convertStringArrayToDate(value) {
  var _value$, _value$2, _value$3;

  var yearString = (_value$ = value[0]) != null ? _value$ : '1900';
  var monthString = (_value$2 = value[1]) != null ? _value$2 : '1';
  var dateString = (_value$3 = value[2]) != null ? _value$3 : '1';
  return new Date(parseInt(yearString), parseInt(monthString) - 1, parseInt(dateString));
}

function prompt(props) {
  return new Promise(function (resolve) {
    var Wrapper = function Wrapper() {
      var _react_1$useState = react_1.useState(false),
          visible = _react_1$useState[0],
          setVisible = _react_1$useState[1];

      react_1.useEffect(function () {
        setVisible(true);
      }, []);
      return react_1["default"].createElement(DatePicker, Object.assign({}, props, {
        visible: visible,
        onConfirm: function onConfirm(val) {
          resolve(val);
        },
        onClose: function onClose() {
          props.onClose == null ? void 0 : props.onClose();
          setVisible(false);
          resolve(null);
        },
        afterClose: function afterClose() {
          props.afterClose == null ? void 0 : props.afterClose();
          unmount();
        }
      }));
    };

    var unmount = render_to_body_1.renderToBody(react_1["default"].createElement(Wrapper, null));
  });
}

exports["default"] = attach_properties_to_component_1.attachPropertiesToComponent(DatePicker, {
  prompt: prompt
});