"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var ahooks_1 = require("ahooks");

var classnames_1 = __importDefault(require("classnames"));

var with_default_props_1 = require("../../utils/with-default-props");

var eye_svg_1 = __importDefault(require("../../assets/eye.svg"));

var eye_close_svg_1 = __importDefault(require("../../assets/eye-close.svg"));

var classPrefix = "am-desens-text";
var DesensText = with_default_props_1.withDefaultProps({
  defaultDesens: true
})(function (props) {
  var text = props.text,
      desensText = props.desensText;

  var _ahooks_1$useControll = ahooks_1.useControllableValue(props, {
    valuePropName: 'desens',
    defaultValuePropName: 'defaultDesens'
  }),
      isDesens = _ahooks_1$useControll[0],
      setIsDesens = _ahooks_1$useControll[1];

  return react_1["default"].createElement("span", {
    className: classnames_1["default"](classPrefix, props.className),
    style: props.style
  }, isDesens ? desensText : text, react_1["default"].createElement("span", {
    className: classPrefix + "-icon-wrap",
    onClick: function onClick() {
      setIsDesens(!isDesens);
    }
  }, react_1["default"].createElement("img", {
    src: isDesens ? eye_close_svg_1["default"] : eye_svg_1["default"],
    className: classPrefix + "-icon"
  })));
});
exports["default"] = DesensText;