"use strict";

var _excluded = ["afterClose", "onCancel", "onOk", "cancelProps", "okProps"];

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _await(value, then, direct) {
  if (direct) {
    return then ? then(value) : value;
  }

  if (!value || !value.then) {
    value = Promise.resolve(value);
  }

  return then ? value.then(then) : value;
}

function _async(f) {
  return function () {
    for (var args = [], i = 0; i < arguments.length; i++) {
      args[i] = arguments[i];
    }

    try {
      return Promise.resolve(f.apply(this, args));
    } catch (e) {
      return Promise.reject(e);
    }
  };
}

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importStar(require("react"));

var react_dom_1 = __importDefault(require("react-dom"));

var classnames_1 = __importDefault(require("classnames"));

var noop_1 = require("../../utils/noop");

var get_container_1 = require("../../utils/get-container");

var button_1 = __importDefault(require("../button"));

var mask_1 = __importDefault(require("../mask"));

var classPrefix = "am-dialog";

var InternalDialog = function InternalDialog(props) {
  var _props$cancelProps, _classnames_1$default, _props$cancelProps2, _props$cancelProps3, _props$cancelProps4, _props$okProps, _props$okProps2, _props$okProps3;

  return react_1["default"].createElement(mask_1["default"], {
    visible: props.visible,
    destroyOnClose: true,
    getContainer: props.getContainer,
    afterClose: props.afterClose,
    onMaskClick: props.maskClosable && !((_props$cancelProps = props.cancelProps) != null && _props$cancelProps.loading) ? props.onCancel : noop_1.noop,
    style: props.maskStyle,
    className: classnames_1["default"](classPrefix + "-mask", props.maskClassName)
  }, react_1["default"].createElement("div", {
    onClick: function onClick(e) {
      return e.stopPropagation();
    },
    className: classPrefix + "-wrap"
  }, Boolean(props.headerImage) && react_1["default"].createElement("div", {
    className: classPrefix + "-image"
  }, react_1["default"].createElement("img", {
    src: props.headerImage,
    alt: 'inside dialog'
  })), react_1["default"].createElement("div", {
    style: props.bodyStyle,
    className: classnames_1["default"](classPrefix + "-body", props.bodyClassName)
  }, Boolean(props.title) && react_1["default"].createElement("div", {
    className: classPrefix + "-body-title"
  }, props.title), Boolean(props.content) && react_1["default"].createElement("div", {
    className: classPrefix + "-body-message-wrapper"
  }, react_1["default"].createElement("div", {
    className: classnames_1["default"](classPrefix + "-body-message", (_classnames_1$default = {}, _classnames_1$default[classPrefix + "-body-message-with-title"] = !!props.title, _classnames_1$default))
  }, props.content))), react_1["default"].createElement("div", {
    className: classPrefix + "-footer"
  }, react_1["default"].createElement(button_1["default"], {
    onClick: (_props$cancelProps2 = props.cancelProps) != null && _props$cancelProps2.loading ? noop_1.noop : props.onCancel,
    className: classPrefix + "-btn-cancel",
    fill: 'none',
    block: true,
    loading: (_props$cancelProps3 = props.cancelProps) == null ? void 0 : _props$cancelProps3.loading,
    disabled: (_props$cancelProps4 = props.cancelProps) == null ? void 0 : _props$cancelProps4.disabled
  }, props.cancelText || (props.okText ? '取消' : '我知道了')), Boolean(props.okText) && react_1["default"].createElement(button_1["default"], {
    onClick: (_props$okProps = props.okProps) != null && _props$okProps.loading ? noop_1.noop : props.onOk,
    loading: (_props$okProps2 = props.okProps) == null ? void 0 : _props$okProps2.loading,
    fill: 'none',
    block: true,
    disabled: (_props$okProps3 = props.okProps) == null ? void 0 : _props$okProps3.disabled,
    className: classPrefix + "-btn-ok"
  }, props.okText || '确认'))));
};

var Dialog = {}; // 可返回用于销毁此弹窗的方法

Dialog.show = function (props) {
  var afterClose = props.afterClose,
      _props$onCancel = props.onCancel,
      onCancel = _props$onCancel === void 0 ? noop_1.noop : _props$onCancel,
      _props$onOk = props.onOk,
      onOk = _props$onOk === void 0 ? noop_1.noop : _props$onOk,
      cancelProps = props.cancelProps,
      okProps = props.okProps,
      restProps = _objectWithoutPropertiesLoose(props, _excluded);

  var userContainer = get_container_1.resolveContainer(props.getContainer);
  var container = document.createElement('div');
  userContainer.appendChild(container);
  var destroy = noop_1.noop;

  var TempDialog = function TempDialog() {
    var _react_1$useState = react_1.useState(false),
        cancelLoading = _react_1$useState[0],
        setCancelLoading = _react_1$useState[1];

    var _react_1$useState2 = react_1.useState(false),
        okLoading = _react_1$useState2[0],
        setOkLoading = _react_1$useState2[1];

    var _react_1$useState3 = react_1.useState(true),
        visible = _react_1$useState3[0],
        setVisible = _react_1$useState3[1];

    destroy = function destroy() {
      setVisible(false);

      if (afterClose) {
        afterClose();
      }
    };

    var _afterClose = function _afterClose() {
      var unmountResult = react_dom_1["default"].unmountComponentAtNode(container);

      if (unmountResult && container.parentNode) {
        container.parentNode.removeChild(container);
      }
    };

    var _onOk = _async(function (e) {
      var i = setTimeout(function () {
        return setOkLoading(true);
      });
      return _await(onOk(e), function (_onOk2) {
        if (_onOk2 !== false) {
          clearTimeout(i);
          destroy();
        } else {
          clearTimeout(i);
          setOkLoading(false);
        }
      });
    });

    var _onCancel = _async(function (e) {
      var i = setTimeout(function () {
        return setCancelLoading(true);
      });
      return _await(onCancel(e), function (_onCancel2) {
        if (_onCancel2 !== false) {
          clearTimeout(i);
          destroy();
        } else {
          clearTimeout(i);
          setCancelLoading(false);
        }
      });
    });

    return react_1["default"].createElement(InternalDialog, Object.assign({}, restProps, {
      visible: visible,
      getContainer: function getContainer() {
        return container;
      },
      cancelProps: _extends({
        loading: cancelLoading
      }, cancelProps),
      okProps: _extends({
        loading: okLoading
      }, okProps),
      onCancel: _onCancel,
      onOk: _onOk,
      afterClose: _afterClose
    }));
  };

  if (props.headerImage && props.waitImageLoad !== false) {
    var preloadImage = new Image();
    preloadImage.src = props.headerImage;

    preloadImage.onload = function () {
      react_dom_1["default"].render(react_1["default"].createElement(TempDialog, null), container);
    };
  } else {
    react_dom_1["default"].render(react_1["default"].createElement(TempDialog, null), container);
  }

  return destroy;
}; // 可使用 async/await 的方式


Dialog.alert = function (props) {
  var _props$onCancel2 = props.onCancel,
      _onCancel3 = _props$onCancel2 === void 0 ? noop_1.noop : _props$onCancel2;

  return new Promise(function (resolve) {
    Dialog.show(_extends({}, props, {
      // 强制不现实 OK Btn
      okText: undefined,
      onOk: noop_1.noop,
      onCancel: function onCancel(e) {
        _onCancel3(e);

        resolve(e);
      }
    }));
  });
};

Dialog.confirm = function (props) {
  var _props$onCancel3 = props.onCancel,
      _onCancel4 = _props$onCancel3 === void 0 ? noop_1.noop : _props$onCancel3,
      _props$onOk2 = props.onOk,
      _onOk3 = _props$onOk2 === void 0 ? noop_1.noop : _props$onOk2;

  return new Promise(function (resolve) {
    Dialog.show(_extends({
      // 强制显示 OK Btn
      okText: '确认'
    }, props, {
      onCancel: function onCancel(e) {
        _onCancel4(e);

        resolve(false);
      },
      onOk: function onOk(e) {
        _onOk3(e);

        resolve(true);
      }
    }));
  });
};

exports["default"] = Dialog;