"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var with_default_props_1 = require("../../utils/with-default-props");

var classPrefix = "am-divider";
var defaultProps = {
  contentPosition: 'center'
};

var Divider = function Divider(p) {
  var props = with_default_props_1.mergeProps(defaultProps, p);
  return react_1["default"].createElement("div", {
    style: props.style,
    className: classnames_1["default"](classPrefix, classPrefix + "-" + props.contentPosition, props.className)
  }, props.children && react_1["default"].createElement("div", {
    className: classPrefix + "-content"
  }, props.children));
};

exports["default"] = Divider;