"use strict";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var ahooks_1 = require("ahooks");

var classnames_1 = __importDefault(require("classnames"));

var react_1 = __importStar(require("react"));

var popup_1 = __importDefault(require("../popup"));

var item_1 = __importDefault(require("./item"));

var classPrefix = "am-dropdown";

var Dropdown = function Dropdown(props) {
  var _classnames_1$default;

  var _ahooks_1$useControll = ahooks_1.useControllableValue(props, {
    valuePropName: 'activeKey'
  }),
      value = _ahooks_1$useControll[0],
      onChange = _ahooks_1$useControll[1];

  var navRef = react_1.useRef(null);
  var contentRef = react_1.useRef(null); // 点击外部区域，关闭

  ahooks_1.useClickAway(function () {
    onChange(undefined);
  }, [navRef, contentRef]); // 计算 navs 的 top 值

  var _react_1$useState = react_1.useState(),
      top = _react_1$useState[0],
      setTop = _react_1$useState[1];

  var containerRef = react_1.useRef(null);
  react_1.useEffect(function () {
    if (value) {
      var rect = containerRef.current.getBoundingClientRect();
      setTop(rect.bottom);
    }
  }, [value]);

  var changeActive = function changeActive(key) {
    if (value === key) {
      onChange(undefined);
    } else {
      onChange(key);
    }
  };

  var contents = {};
  var navs = react_1["default"].Children.map(props.children, function (child) {
    if (react_1["default"].isValidElement(child)) {
      var childProps = _extends({}, child.props, {
        onClick: function onClick() {
          changeActive(child.key);
        },
        active: child.key === value
      });

      contents[child.key] = child.props.children;
      return react_1.cloneElement(child, childProps);
    } else {
      return child;
    }
  });
  return react_1["default"].createElement("div", {
    className: classnames_1["default"](classPrefix, props.className, (_classnames_1$default = {}, _classnames_1$default[classPrefix + "-open"] = !!value, _classnames_1$default)),
    style: props.style,
    ref: containerRef
  }, react_1["default"].createElement("div", {
    className: classPrefix + "-nav",
    ref: navRef
  }, navs), react_1["default"].createElement(popup_1["default"], {
    visible: !!value,
    position: 'top',
    className: classPrefix + "-popup",
    maskClassName: classPrefix + "-popup-mask",
    bodyClassName: classPrefix + "-popup-body",
    style: {
      top: top
    },
    forceRender: props.forceRender
  }, react_1["default"].createElement("div", {
    ref: contentRef
  }, Object.keys(contents).map(function (key) {
    var _classnames_1$default2;

    var isActive = key === value;
    var cls = classnames_1["default"](classPrefix + "-content", (_classnames_1$default2 = {}, _classnames_1$default2[classPrefix + "-content-hidden"] = !isActive, _classnames_1$default2));

    if (!props.forceRender && !isActive) {
      return null;
    }

    return react_1["default"].createElement("div", {
      className: cls,
      key: key
    }, contents[key]);
  }))));
};

Dropdown.Item = item_1["default"];
exports["default"] = Dropdown;