"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var error_1 = require("./error");

var with_default_props_1 = require("../../utils/with-default-props");

var classPrefix = "am-error";
var defaultProps = {
  status: 'default'
};
var Error = with_default_props_1.withDefaultProps(defaultProps)(function (props) {
  var _classnames_1$default;

  var config = error_1.errorConfigRecord[props.status];
  var des = 'description' in props ? props.description : config.description;
  var title = 'title' in props ? props.title : config.title;
  var imageNode = react_1["default"].createElement("img", {
    src: config.icon
  });

  if (props.image) {
    if (typeof props.image === 'string') {
      imageNode = react_1["default"].createElement("img", {
        src: props.image
      });
    } else {
      imageNode = props.image;
    }
  }

  return react_1["default"].createElement("div", {
    className: classnames_1["default"](classPrefix, props.className, (_classnames_1$default = {}, _classnames_1$default[classPrefix + "-full-page"] = props.fullPage, _classnames_1$default)),
    style: props.style
  }, react_1["default"].createElement("div", {
    className: classPrefix + "-image"
  }, imageNode), react_1["default"].createElement("div", {
    className: classPrefix + "-description"
  }, title && react_1["default"].createElement("span", {
    className: classPrefix + "-description-title"
  }, title), des && react_1["default"].createElement("span", {
    className: classPrefix + "-description-subtitle"
  }, des)), props.children && react_1["default"].createElement("div", {
    className: classPrefix + "-content"
  }, props.children));
});
exports["default"] = Error;