"use strict";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importStar(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var react_use_gesture_1 = require("react-use-gesture");

var web_1 = require("@react-spring/web");

var supports_passive_1 = require("../../utils/supports-passive");

var nearest_1 = require("../../utils/nearest");

var FloatingPanel = react_1.forwardRef(function (props, ref) {
  var _anchors;

  var anchors = props.anchors;
  var maxHeight = (_anchors = anchors[anchors.length - 1]) != null ? _anchors : window.innerHeight;
  var possibles = anchors.map(function (x) {
    return -x;
  });
  var elementRef = react_1.useRef(null);
  var headerRef = react_1.useRef(null);
  var contentRef = react_1.useRef(null);
  var pullingRef = react_1.useRef(false);
  var bounds = {
    top: possibles[possibles.length - 1],
    bottom: possibles[0]
  };

  var _web_1$useSpring = web_1.useSpring(function () {
    return {
      y: bounds.bottom,
      config: {
        tension: 300
      }
    };
  }),
      y = _web_1$useSpring[0].y,
      api = _web_1$useSpring[1];

  react_use_gesture_1.useDrag(function (state) {
    var _state$movement = state.movement,
        _ = _state$movement[0],
        movementY = _state$movement[1];

    if (state.first) {
      var target = state.event.target;
      var header = headerRef.current;

      if (header === target || header != null && header.contains(target)) {
        pullingRef.current = true;
      } else {
        var reachedTop = y.get() <= bounds.top;
        var content = contentRef.current;
        if (!content) return;

        if (reachedTop) {
          if (content.scrollTop <= 0 && state.vxvy[1] > 0) {
            pullingRef.current = true;
          }
        } else {
          pullingRef.current = true;
        }
      }
    }

    if (!pullingRef.current) return;
    var event = state.event;

    if (event.cancelable) {
      event.preventDefault();
    }

    event.stopPropagation();
    var nextY = movementY;

    if (state.last) {
      pullingRef.current = false;
      nextY = nearest_1.nearest(possibles, movementY);
    }

    api.start({
      y: nextY
    });
  }, {
    axis: 'y',
    bounds: bounds,
    rubberband: true,
    initial: function initial() {
      return [0, y.get()];
    },
    useTouch: true,
    domTarget: elementRef,
    eventOptions: supports_passive_1.supportsPassive ? {
      passive: false
    } : false
  });
  react_1.useImperativeHandle(ref, function () {
    return {
      setHeight: function setHeight(height, options) {
        api.start({
          y: -height,
          immediate: options == null ? void 0 : options.immediate
        });
      }
    };
  }, [api]);
  return react_1["default"].createElement(web_1.animated.div, {
    ref: elementRef,
    className: classnames_1["default"]('am-drawer', props.className),
    style: _extends({}, props.style, {
      height: maxHeight,
      y: y
    })
  }, react_1["default"].createElement("div", {
    className: 'am-drawer-header',
    ref: headerRef
  }, react_1["default"].createElement("div", {
    className: 'am-drawer-bar'
  })), react_1["default"].createElement("div", {
    className: 'am-drawer-content',
    ref: contentRef
  }, props.children));
});
exports["default"] = FloatingPanel;