import React, { FC } from 'react';
import { ElementProps } from '../../utils/element-props';
import { FormInstance } from 'rc-field-form';
import type { FieldProps } from 'rc-field-form/lib/Field';
declare type RenderChildren<Values = any> = (form: FormInstance<Values>) => React.ReactNode;
declare type ChildrenType<Values = any> = RenderChildren<Values> | React.ReactNode;
declare type RcFieldProps = Omit<FieldProps, 'children'>;
declare type FormItemProps = RcFieldProps & ElementProps & {
    label?: string;
    help?: string;
    hasFeedback?: boolean;
    required?: boolean;
    noStyle?: boolean;
    disabled?: boolean;
    children: ChildrenType;
};
export declare const FormItem: FC<FormItemProps>;
export {};
