"use strict";

var _excluded = ["className", "style", "hasFeedback", "children"];

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Form = void 0;

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var rc_field_form_1 = __importDefault(require("rc-field-form"));

var context_1 = require("./context");

var classPrefix = "am-form";

exports.Form = function (props) {
  var className = props.className,
      style = props.style,
      hasFeedback = props.hasFeedback,
      children = props.children,
      formProps = _objectWithoutPropertiesLoose(props, _excluded);

  var formClassName = classnames_1["default"](classPrefix, className);
  return react_1["default"].createElement(rc_field_form_1["default"], Object.assign({
    className: formClassName,
    style: style
  }, formProps), react_1["default"].createElement(context_1.FormContext.Provider, {
    value: {
      hasFeedback: hasFeedback || context_1.DEFAULT_FORM_CONTEXT.hasFeedback
    }
  }, children));
};