"use strict";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var with_default_props_1 = require("../../utils/with-default-props");

var attach_properties_to_component_1 = require("../../utils/attach-properties-to-component");

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var classPrefix = "am-grid";
var defaultProps = {
  gap: 0
};
var Grid = with_default_props_1.withDefaultProps(defaultProps)(function (props) {
  var gapStyle = {};

  if (props.style) {
    gapStyle = _extends({}, gapStyle, props.style);
  }

  var gap = props.gap;

  if (gap) {
    var _ref = Array.isArray(gap) ? gap : [gap, gap],
        horizontalGap = _ref[0],
        verticalGap = _ref[1];

    gapStyle = _extends({}, gapStyle, {
      '--vertical-gap': typeof verticalGap === 'number' ? verticalGap + "px" : verticalGap,
      '--horizontal-gap': typeof horizontalGap === 'number' ? horizontalGap + "px" : horizontalGap
    });
  }

  return react_1["default"].createElement("div", {
    className: classnames_1["default"]("" + classPrefix, props.className),
    style: _extends({}, gapStyle, {
      '--columns': props.columns
    })
  }, props.children);
});
var GridItem = with_default_props_1.withDefaultProps({
  span: 1
})(function (props) {
  var _props$style;

  var itemStyle = (_props$style = props.style) != null ? _props$style : {};
  itemStyle = _extends({}, itemStyle, {
    '--item-span': props.span
  });
  return react_1["default"].createElement("div", {
    className: classnames_1["default"](classPrefix + "-item", props.className),
    style: itemStyle
  }, props.children);
});
exports["default"] = attach_properties_to_component_1.attachPropertiesToComponent(Grid, {
  Item: GridItem
});