"use strict";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var with_default_props_1 = require("../../utils/with-default-props");

var render_to_container_1 = require("../../utils/render-to-container");

var mask_1 = __importDefault(require("../mask"));

var slide_1 = require("./slide");

var attach_properties_to_component_1 = require("../../utils/attach-properties-to-component");

var slides_1 = require("./slides");

var react_1 = __importStar(require("react"));

var render_to_body_1 = require("../../utils/render-to-body");

var classPrefix = "am-image-viewer";
var defaultProps = {
  maxZoom: 3,
  getContainer: null,
  visible: false
};
var ImageViewer = with_default_props_1.withDefaultProps(defaultProps)(function (props) {
  var node = react_1["default"].createElement(mask_1["default"], {
    visible: props.visible,
    disableBodyScroll: false,
    opacity: 'dark',
    afterClose: props.afterClose
  }, react_1["default"].createElement("div", {
    className: classPrefix + "-content"
  }, props.image && react_1["default"].createElement(slide_1.Slide, {
    image: props.image,
    onTap: function onTap() {
      props.onClose == null ? void 0 : props.onClose();
    },
    maxZoom: props.maxZoom
  })));
  return render_to_container_1.renderToContainer(props.getContainer, node);
});

var multiDefaultProps = _extends({}, defaultProps, {
  defaultIndex: 0
});

var MultiImageViewer = with_default_props_1.withDefaultProps(multiDefaultProps)(function (props) {
  var node = react_1["default"].createElement(mask_1["default"], {
    visible: props.visible,
    disableBodyScroll: false,
    opacity: 'dark',
    afterClose: props.afterClose
  }, react_1["default"].createElement("div", {
    className: classPrefix + "-content"
  }, props.images && react_1["default"].createElement(slides_1.Slides, {
    defaultIndex: props.defaultIndex,
    onIndexChange: props.onIndexChange,
    images: props.images,
    onTap: function onTap() {
      props.onClose == null ? void 0 : props.onClose();
    },
    maxZoom: props.maxZoom
  })));
  return render_to_container_1.renderToContainer(props.getContainer, node);
});

function showImageViewer(props) {
  var Wrapper = react_1.forwardRef(function (_, ref) {
    var _react_1$useState = react_1.useState(true),
        visible = _react_1$useState[0],
        setVisible = _react_1$useState[1];

    react_1.useImperativeHandle(ref, function () {
      return {
        close: function close() {
          setVisible(false);
        }
      };
    });
    return react_1["default"].createElement(ImageViewer, Object.assign({}, props, {
      visible: visible,
      onClose: function onClose() {
        props.onClose == null ? void 0 : props.onClose();
        setVisible(false);
      },
      afterClose: function afterClose() {
        props.afterClose == null ? void 0 : props.afterClose();
        unmount();
      }
    }));
  });
  var ref = react_1.createRef();
  var unmount = render_to_body_1.renderToBody(react_1["default"].createElement(Wrapper, {
    ref: ref
  }));
  return {
    close: function close() {
      var _ref$current;

      (_ref$current = ref.current) == null ? void 0 : _ref$current.close();
    }
  };
}

function showMultiImageViewer(props) {
  var Wrapper = react_1.forwardRef(function (_, ref) {
    var _react_1$useState2 = react_1.useState(true),
        visible = _react_1$useState2[0],
        setVisible = _react_1$useState2[1];

    react_1.useImperativeHandle(ref, function () {
      return {
        close: function close() {
          setVisible(false);
        }
      };
    });
    return react_1["default"].createElement(MultiImageViewer, Object.assign({}, props, {
      visible: visible,
      onClose: function onClose() {
        props.onClose == null ? void 0 : props.onClose();
        setVisible(false);
      },
      afterClose: function afterClose() {
        props.afterClose == null ? void 0 : props.afterClose();
        unmount();
      }
    }));
  });
  var ref = react_1.createRef();
  var unmount = render_to_body_1.renderToBody(react_1["default"].createElement(Wrapper, {
    ref: ref
  }));
  return {
    close: function close() {
      var _ref$current2;

      (_ref$current2 = ref.current) == null ? void 0 : _ref$current2.close();
    }
  };
}

var Multi = attach_properties_to_component_1.attachPropertiesToComponent(MultiImageViewer, {
  show: showMultiImageViewer
});
exports["default"] = attach_properties_to_component_1.attachPropertiesToComponent(ImageViewer, {
  Multi: Multi,
  show: showImageViewer
});