"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Slide = void 0;

var react_1 = __importDefault(require("react"));

var react_use_gesture_1 = require("react-use-gesture");

var web_1 = require("@react-spring/web");

var classPrefix = "am-image-viewer";

exports.Slide = function (props) {
  var _web_1$useSpring = web_1.useSpring(function () {
    return {
      zoom: 1,
      x: 0,
      y: 0,
      config: {
        tension: 300
      }
    };
  }),
      _web_1$useSpring$ = _web_1$useSpring[0],
      zoom = _web_1$useSpring$.zoom,
      x = _web_1$useSpring$.x,
      y = _web_1$useSpring$.y,
      api = _web_1$useSpring[1];

  var bind = react_use_gesture_1.useGesture({
    onDrag: function onDrag(state) {
      if (state.tap && state.elapsedTime > 0) {
        // 判断点击时间>0是为了过滤掉非正常操作，例如用户长按选择图片之后的取消操作（也是一次点击）
        props.onTap();
        return;
      }

      var currentZoom = zoom.get();

      if (currentZoom <= 1) {
        api.start({
          x: 0,
          y: 0
        });
      } else {
        var _state$movement = state.movement,
            _x = _state$movement[0],
            _y = _state$movement[1];
        api.start({
          x: _x,
          y: _y
        });
      }
    },
    onPinch: function onPinch(state) {
      var _state$movement2 = state.movement,
          d = _state$movement2[0],
          a = _state$movement2[1]; // pinch的rubberband不会自动弹回bound，这里手动实现了

      var zoom = state.last ? Math.max(Math.min(d, props.maxZoom), 1) : d;
      api.start({
        zoom: zoom
      });
      props.onZoomChange == null ? void 0 : props.onZoomChange(zoom);

      if (state.last && zoom <= 1) {
        api.start({
          x: 0,
          y: 0
        });
      }
    }
  }, {
    drag: {
      // filterTaps: true,
      initial: function initial() {
        return [x.get(), y.get()];
      }
    },
    pinch: {
      distanceBounds: {
        min: 1,
        max: props.maxZoom
      },
      rubberband: true,
      transform: function transform(_ref) {
        var x = _ref[0],
            y = _ref[1];
        return [x / 200, y / 200];
      },
      initial: function initial() {
        return [zoom.get(), 0];
      }
    }
  });
  return react_1["default"].createElement("div", {
    className: classPrefix + "-slide",
    onPointerMove: function onPointerMove(e) {
      if (zoom.get() !== 1) {
        e.stopPropagation();
      }
    }
  }, react_1["default"].createElement("div", Object.assign({
    className: classPrefix + "-control"
  }, bind()), react_1["default"].createElement(web_1.animated.div, {
    className: classPrefix + "-image-wrapper",
    style: {
      scale: zoom,
      x: x,
      y: y
    }
  }, react_1["default"].createElement("img", {
    src: props.image,
    draggable: false
  }))));
};