"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Slides = void 0;

var react_1 = __importDefault(require("react"));

var react_use_gesture_1 = require("react-use-gesture");

var web_1 = require("@react-spring/web");

var slide_1 = require("./slide");

var convert_px_1 = require("../../utils/convert-px");

var rubberband_1 = require("../../utils/rubberband");

var classPrefix = "am-image-viewer";

exports.Slides = function (props) {
  var slideWidth = window.innerWidth + convert_px_1.convertPx(16);

  var _web_1$useSpring = web_1.useSpring(function () {
    return {
      x: -props.defaultIndex * slideWidth,
      config: {
        tension: 300
      }
    };
  }),
      x = _web_1$useSpring[0].x,
      api = _web_1$useSpring[1];

  var count = props.images.length;
  var bind = react_use_gesture_1.useDrag(function (state) {
    var _state$movement = state.movement,
        mx = _state$movement[0];

    if (state.last) {
      var index = rubberband_1.bound(-Math.round((mx + state.vxvy[0] * 100) / slideWidth), 0, count - 1);
      api.start({
        x: index * -slideWidth
      });
    } else {
      api.start({
        x: mx
      });
    }
  }, {
    initial: function initial() {
      return [x.get(), 0];
    },
    bounds: function bounds() {
      var index = -Math.round(x.get() / slideWidth);
      return {
        right: Math.max(index - 1, 0) * -slideWidth,
        left: Math.min(index + 1, count - 1) * -slideWidth
      };
    },
    rubberband: true,
    axis: 'x'
  });
  return react_1["default"].createElement("div", Object.assign({
    className: classPrefix + "-slides"
  }, bind()), react_1["default"].createElement(web_1.animated.div, {
    className: classPrefix + "-indicator"
  }, x.to(function (v) {
    var index = -Math.round(v / slideWidth);
    return index + 1 + " / " + count;
  })), react_1["default"].createElement(web_1.animated.div, {
    className: classPrefix + "-slides-inner",
    style: {
      x: x
    }
  }, props.images.map(function (image) {
    return react_1["default"].createElement(slide_1.Slide, {
      key: image,
      image: image,
      onTap: props.onTap,
      maxZoom: props.maxZoom,
      onZoomChange: function onZoomChange(zoom) {
        if (zoom !== 1) {
          var index = -Math.round(x.get() / slideWidth);
          api.start({
            x: index * -slideWidth
          });
        }
      }
    });
  })));
};