import React, { FC, ReactNode } from 'react';
import { ElementProps } from '../../utils/element-props';
export declare type ImageProps = {
    src: string;
    alt?: string;
    width?: number | string;
    height?: number | string;
    fit?: 'contain' | 'cover' | 'fill' | 'none' | 'scale-down';
    placeholder?: ReactNode;
    fallback?: ReactNode;
    onClick?: (event: React.SyntheticEvent<HTMLImageElement, Event>) => void;
    onError?: (event: React.SyntheticEvent<HTMLImageElement, Event>) => void;
} & ElementProps & Pick<React.ImgHTMLAttributes<HTMLImageElement>, 'crossOrigin' | 'decoding' | 'loading' | 'referrerPolicy' | 'sizes' | 'srcSet' | 'useMap'>;
declare const Image: FC<ImageProps>;
export default Image;
