"use strict";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var with_default_props_1 = require("../../utils/with-default-props");

var react_1 = __importStar(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var icons_1 = require("@ant-design/icons");

var classPrefix = "am-image";
var defaultProps = {
  fit: 'fill',
  placeholder: react_1["default"].createElement("div", {
    className: classPrefix + "-tip"
  }, react_1["default"].createElement(icons_1.PictureOutlined, null)),
  fallback: react_1["default"].createElement("div", {
    className: classPrefix + "-tip"
  }, react_1["default"].createElement(icons_1.DisconnectOutlined, null))
};

var Image = function Image(p) {
  var props = with_default_props_1.mergeProps(defaultProps, p);

  var _react_1$useState = react_1.useState(false),
      loaded = _react_1$useState[0],
      setLoaded = _react_1$useState[1];

  var _react_1$useState2 = react_1.useState(false),
      failed = _react_1$useState2[0],
      setFailed = _react_1$useState2[1];

  function renderInner() {
    if (failed) {
      return props.fallback;
    }

    return react_1["default"].createElement(react_1["default"].Fragment, null, !loaded && props.placeholder, react_1["default"].createElement("img", {
      className: classPrefix + "-img",
      src: props.src,
      alt: props.alt,
      onClick: props.onClick,
      onLoad: function onLoad() {
        setLoaded(true);
      },
      onError: function onError(e) {
        setFailed(true);
        props.onError == null ? void 0 : props.onError(e);
      },
      style: {
        objectFit: props.fit,
        display: loaded ? 'block' : 'none'
      },
      crossOrigin: props.crossOrigin,
      decoding: props.decoding,
      loading: props.loading,
      referrerPolicy: props.referrerPolicy,
      sizes: props.sizes,
      srcSet: props.srcSet,
      useMap: props.useMap
    }));
  }

  return react_1["default"].createElement("div", {
    className: classnames_1["default"](classPrefix, props.className),
    style: _extends({
      width: props.width,
      height: props.height
    }, props.style)
  }, renderInner());
};

exports["default"] = Image;