"use strict";

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importStar(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var panel_1 = require("./panel");

var attach_properties_to_component_1 = require("../../utils/attach-properties-to-component");

var ahooks_1 = require("ahooks");

var with_default_props_1 = require("../../utils/with-default-props");

var sidebar_1 = require("./sidebar");

var context_1 = require("./context");

var convert_px_1 = require("../../utils/convert-px");

var classPrefix = "am-index-bar";
var defaultProps = {
  sticky: true
};
var IndexBar = with_default_props_1.withDefaultProps(defaultProps)(function (props) {
  var _classnames_1$default;

  var titleHeight = convert_px_1.convertPx(35);
  var bodyRef = react_1.useRef(null);

  var _react_1$useState = react_1.useState([]),
      indexes = _react_1$useState[0],
      setIndexes = _react_1$useState[1];

  var _react_1$useState2 = react_1.useState(indexes[0]),
      activeIndex = _react_1$useState2[0],
      setActiveIndex = _react_1$useState2[1];

  function scrollTo(index) {
    var body = bodyRef.current;
    if (!body) return;
    var children = body.children;

    for (var i = 0; i < children.length; i++) {
      var panel = children.item(i);
      if (!panel) continue;
      var panelIndex = panel.dataset['index'];

      if (panelIndex === index) {
        body.scrollTop = panel.offsetTop;
        setActiveIndex(index);
        return;
      }
    }
  }

  var _ahooks_1$useThrottle = ahooks_1.useThrottleFn(function () {
    var body = bodyRef.current;
    if (!body) return;
    var scrollTop = body.scrollTop;
    var children = body.getElementsByClassName(classPrefix + "-anchor");

    for (var i = 0; i < children.length; i++) {
      var panel = children.item(i);
      if (!panel) continue;
      var panelIndex = panel.dataset['index'];
      if (!panelIndex) continue;

      if (panel.offsetTop + panel.clientHeight - titleHeight > scrollTop) {
        setActiveIndex(panelIndex);
        return;
      }
    }
  }, {
    wait: 50,
    trailing: true,
    leading: true
  }),
      checkActiveIndex = _ahooks_1$useThrottle.run;

  react_1.useEffect(function () {
    if (!indexes.length) return;
    checkActiveIndex();
  }, [indexes]);
  var stickyStyle;

  if (props.stickyOffsetTop) {
    stickyStyle = {
      '--sticy-offset-top': props.stickyOffsetTop + 'px'
    };
  }

  return react_1["default"].createElement(context_1.IndexBarContext.Provider, {
    value: {
      indexes: indexes,
      setIndexes: setIndexes
    }
  }, react_1["default"].createElement("div", {
    className: classnames_1["default"]("" + classPrefix, (_classnames_1$default = {}, _classnames_1$default[classPrefix + "-sticky"] = props.sticky, _classnames_1$default), props.className),
    style: stickyStyle
  }, react_1["default"].createElement(sidebar_1.Sidebar, {
    indexes: indexes,
    activeIndex: activeIndex,
    onActive: function onActive(index) {
      scrollTo(index);
    }
  }), react_1["default"].createElement("div", {
    className: classPrefix + "-body",
    ref: bodyRef,
    onScroll: checkActiveIndex
  }, props.children)));
});
exports["default"] = attach_properties_to_component_1.attachPropertiesToComponent(IndexBar, {
  Panel: panel_1.Panel
});