"use strict";

function _empty() {}

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

function _awaitIgnored(value, direct) {
  if (!direct) {
    return value && value.then ? value.then(_empty) : Promise.resolve();
  }
}

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

function _async(f) {
  return function () {
    for (var args = [], i = 0; i < arguments.length; i++) {
      args[i] = arguments[i];
    }

    try {
      return Promise.resolve(f.apply(this, args));
    } catch (e) {
      return Promise.reject(e);
    }
  };
}

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var with_default_props_1 = require("../../utils/with-default-props");

var react_1 = __importStar(require("react"));

var ahooks_1 = require("ahooks");

var classnames_1 = __importDefault(require("classnames"));

var get_scroll_parent_1 = require("../../utils/get-scroll-parent");

var loading_1 = __importDefault(require("../loading"));

function isWindow(element) {
  return element === window;
}

var classPrefix = "am-infinite-scroll";

var InfiniteScrollContent = function InfiniteScrollContent(_ref) {
  var hasMore = _ref.hasMore;
  return react_1["default"].createElement(react_1["default"].Fragment, null, hasMore ? react_1["default"].createElement(react_1["default"].Fragment, null, react_1["default"].createElement("span", null, "\u52A0\u8F7D\u4E2D"), react_1["default"].createElement(loading_1["default"], {
    size: 'small'
  })) : react_1["default"].createElement("span", null, "\u6CA1\u6709\u66F4\u591A\u4E86"));
};

var InfiniteScroll = with_default_props_1.withDefaultProps({
  threshold: 250
})(function (props) {
  var doLoadMore = ahooks_1.useLockFn(_async(function () {
    return _awaitIgnored(props.loadMore());
  }));
  var elementRef = react_1.useRef(null);
  var check = ahooks_1.usePersistFn(function () {
    if (!props.hasMore) return;
    var element = elementRef.current;
    if (!element) return;
    var parent = get_scroll_parent_1.getScrollParent(element);
    if (!parent) return;
    var elementTop = element.getBoundingClientRect().top;
    var current = isWindow(parent) ? window.innerHeight : parent.getBoundingClientRect().bottom;

    if (current >= elementTop - props.threshold) {
      doLoadMore();
    }
  }); // 确保在内容不足时会自动触发加载事件

  react_1.useEffect(function () {
    check();
  });
  react_1.useEffect(function () {
    var element = elementRef.current;
    if (!element) return;
    var parent = get_scroll_parent_1.getScrollParent(element);
    if (!parent) return;

    function onScroll() {
      check();
    }

    parent.addEventListener('scroll', onScroll);
    return function () {
      parent.removeEventListener('scroll', onScroll);
    };
  }, []);
  return react_1["default"].createElement("div", {
    className: classnames_1["default"](classPrefix, props.className),
    style: props.style,
    ref: elementRef
  }, props.children && props.children, !props.children && react_1["default"].createElement(InfiniteScrollContent, {
    hasMore: props.hasMore
  }));
});
exports["default"] = InfiniteScroll;