"use strict";

var _excluded = ["clearable", "onClear", "className", "style", "defaultValue", "value", "onChange"];

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importStar(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var ahooks_1 = require("ahooks");

var icons_1 = require("@ant-design/icons");

var classPrefix = "am-input";
var Input = react_1.forwardRef(function (props, ref) {
  var clearable = props.clearable,
      onClear = props.onClear,
      className = props.className,
      style = props.style,
      outerDefaultValue = props.defaultValue,
      outerValue = props.value,
      outerOnChange = props.onChange,
      inputProps = _objectWithoutPropertiesLoose(props, _excluded);

  var _ahooks_1$useControll = ahooks_1.useControllableValue(props, {
    defaultValue: ''
  }),
      value = _ahooks_1$useControll[0],
      setValue = _ahooks_1$useControll[1];

  var _react_1$useState = react_1.useState(false),
      hasFocus = _react_1$useState[0],
      setHasFocus = _react_1$useState[1];

  var nativeInputRef = react_1.useRef(null);
  react_1.useImperativeHandle(ref, function () {
    return {
      clear: function clear() {
        setValue('');
      },
      focus: function focus() {
        var _nativeInputRef$curre;

        (_nativeInputRef$curre = nativeInputRef.current) == null ? void 0 : _nativeInputRef$curre.focus();
      },
      blur: function blur() {
        var _nativeInputRef$curre2;

        (_nativeInputRef$curre2 = nativeInputRef.current) == null ? void 0 : _nativeInputRef$curre2.blur();
      }
    };
  });
  return react_1["default"].createElement("div", {
    className: classnames_1["default"](classPrefix + "-wrapper", className),
    style: style
  }, react_1["default"].createElement("input", Object.assign({
    ref: nativeInputRef
  }, inputProps, {
    className: classPrefix,
    value: value,
    onChange: function onChange(e) {
      setValue(e.target.value);
    },
    onFocus: function onFocus(e) {
      setHasFocus(true);
      props.onFocus == null ? void 0 : props.onFocus(e);
    },
    onBlur: function onBlur(e) {
      setHasFocus(false);
      props.onBlur == null ? void 0 : props.onBlur(e);
    }
  })), props.clearable && !!value && hasFocus && react_1["default"].createElement("div", {
    className: classPrefix + "-clear",
    onMouseDown: function onMouseDown(e) {
      e.preventDefault();
    },
    onClick: function onClick() {
      setValue('');
      props.onClear == null ? void 0 : props.onClear();
    }
  }, react_1["default"].createElement(icons_1.CloseCircleFilled, null)));
});
exports["default"] = Input;