"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var icons_1 = require("@ant-design/icons");

var classPrefix = "am-list";

var ListItem = function ListItem(props) {
  var _props$clickable;

  var clickable = (_props$clickable = props.clickable) != null ? _props$clickable : !!props.onClick;
  var arrow = props.arrow === undefined ? clickable : props.arrow;
  var content = react_1["default"].createElement("div", {
    className: classPrefix + "-item-content"
  }, props.prefix && react_1["default"].createElement("div", {
    className: classPrefix + "-item-content-prefix"
  }, props.prefix), react_1["default"].createElement("div", {
    className: classPrefix + "-item-content-main"
  }, props.title && react_1["default"].createElement("div", {
    className: classPrefix + "-item-title"
  }, props.title), react_1["default"].createElement("div", null, props.children), props.description && react_1["default"].createElement("div", {
    className: classPrefix + "-item-description"
  }, props.description)), props.extra && react_1["default"].createElement("div", {
    className: classPrefix + "-item-content-extra"
  }, props.extra), arrow && react_1["default"].createElement("div", {
    className: classPrefix + "-item-content-arrow"
  }, arrow === true ? react_1["default"].createElement(icons_1.RightOutlined, null) : arrow));
  return react_1["default"].createElement(clickable ? 'a' : 'div', {
    className: classnames_1["default"](classPrefix + "-item", props.className, clickable ? ['am-plain-anchor'] : []),
    style: props.style,
    onClick: props.onClick
  }, content);
};

var List = function List(props) {
  var className = classnames_1["default"](classPrefix, classPrefix + "-" + props.mode, props.className);
  return react_1["default"].createElement("div", {
    className: className,
    style: props.style
  }, react_1["default"].createElement("div", {
    className: classPrefix + "-inner"
  }, props.children));
};

List.defaultProps = {
  mode: 'default'
};
List.Item = ListItem;
exports["default"] = List;