import React from 'react';
export interface NoticeBarProps {
    /** 通告栏的类型 */
    type?: 'default' | 'error' | 'info';
    /** 开始滚动的延迟，单位 ms */
    delay?: number;
    /** 滚动速度，单位 px/s */
    speed?: number;
    /** 公告内容 */
    content: React.ReactNode;
    /** 是否可关闭 */
    closeable?: boolean;
    /** 关闭时的回调 */
    onClose?: () => void;
    /** 额外操作区域，显示在关闭按钮左侧 */
    extra?: React.ReactNode;
    /** 左侧广播图标 */
    icon?: React.ReactNode;
}
declare const NoticeBar: React.NamedExoticComponent<NoticeBarProps>;
export default NoticeBar;
