"use strict";

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importStar(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var icons_1 = require("@ant-design/icons");

var ahooks_1 = require("ahooks");

var noop_1 = require("../../utils/noop");

var with_default_props_1 = require("../../utils/with-default-props");

var classPrefix = "am-notice-bar";
var defaultProps = {
  delay: 2000,
  speed: 50
};
var NoticeBar = react_1.memo(with_default_props_1.withDefaultProps(defaultProps)(function (props) {
  var containerRef = react_1.useRef(null);
  var textRef = react_1.useRef(null);

  var _react_1$useState = react_1.useState(0),
      key = _react_1$useState[0],
      setKey = _react_1$useState[1];

  var onClose = ahooks_1.usePersistFn(props.onClose || noop_1.noop);
  var speed = props.speed;
  react_1.useLayoutEffect(function () {
    var container = containerRef.current;
    var text = textRef.current;
    if (!container || !text) return;
    if (container.offsetWidth >= text.offsetWidth) return; // 需要滚动

    var timeout = window.setTimeout(function () {
      var text = textRef.current; // 开始滚动

      if (text) {
        text.style.transitionDuration = Math.round(text.offsetWidth / speed) + "s";
        text.style.transform = "translateX(-" + text.offsetWidth + "px)";
      }
    }, props.delay);
    return function () {
      window.clearTimeout(timeout);
    };
  }, []);
  ahooks_1.useUpdateLayoutEffect(function () {
    var container = containerRef.current;
    var text = textRef.current;
    if (!container || !text) return;
    if (container.offsetWidth >= text.offsetWidth) return;
    text.style.transform = "translateX(" + container.offsetWidth + "px)";
    text.style.transitionDuration = Math.round((container.offsetWidth + text.offsetWidth) / speed) + "s";
    text.style.transform = "translateX(-" + text.offsetWidth + "px)";
  }, [key]);
  return react_1["default"].createElement("div", {
    className: classnames_1["default"](classPrefix, classPrefix + "-" + (props.type || 'default'))
  }, react_1["default"].createElement("span", {
    className: classPrefix + "-left"
  }, 'icon' in props ? props.icon : react_1["default"].createElement(icons_1.SoundOutlined, null)), react_1["default"].createElement("span", {
    ref: containerRef,
    className: classPrefix + "-content"
  }, react_1["default"].createElement("span", {
    onTransitionEnd: function onTransitionEnd() {
      return setKey(function (k) {
        return k + 1;
      });
    },
    key: key,
    ref: textRef,
    className: classPrefix + "-content-inner"
  }, props.content)), (props.closeable || 'extra' in props) && react_1["default"].createElement("span", {
    className: classPrefix + "-right"
  }, props.extra, props.closeable && react_1["default"].createElement(icons_1.CloseOutlined, {
    onClick: onClose
  })));
}));
exports["default"] = NoticeBar;