"use strict";

var _excluded = ["options"];

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Cascader = void 0;

var react_1 = __importStar(require("react"));

var _1 = __importDefault(require("."));

exports.Cascader = function (props) {
  var options = props.options,
      pickerProps = _objectWithoutPropertiesLoose(props, _excluded);

  var _react_1$useMemo = react_1.useMemo(function () {
    var depth = 1;
    var subOptionsRecord = {};

    function traverse(option, currentDepth) {
      if (!option.children) {
        return;
      }

      subOptionsRecord[option.value] = option.children;
      var nextDepth = currentDepth + 1;

      if (nextDepth > depth) {
        depth = nextDepth;
      }

      option.children.forEach(function (option) {
        traverse(option, nextDepth);
      });
    }

    options.forEach(function (option) {
      traverse(option, 1);
    });
    return {
      depth: depth,
      subOptionsRecord: subOptionsRecord
    };
  }, [options]),
      depth = _react_1$useMemo.depth,
      subOptionsRecord = _react_1$useMemo.subOptionsRecord;

  function columns(value) {
    var columns = [];
    columns.push(options.map(function (option) {
      return {
        label: option.label,
        value: option.value
      };
    }));

    for (var i = 0; i < depth - 1; i++) {
      var x = value[i];
      var subOptions = subOptionsRecord[x];

      if (!subOptions) {
        columns.push([]);
      } else {
        columns.push(subOptions.map(function (option) {
          return {
            label: option.label,
            value: option.value
          };
        }));
      }
    }

    return columns;
  }

  return react_1["default"].createElement(_1["default"], Object.assign({}, pickerProps, {
    columns: columns
  }));
};