"use strict";

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Column = void 0;

var react_1 = __importStar(require("react"));

var web_1 = require("@react-spring/web");

var react_use_gesture_1 = require("react-use-gesture");

var convert_px_1 = require("../../utils/convert-px");

var rubberband_1 = require("../../utils/rubberband");

var classPrefix = "am-picker";

exports.Column = function (props) {
  var itemHeight = convert_px_1.convertPx(34);
  var value = props.value,
      onSelect = props.onSelect,
      column = props.column;

  var _web_1$useSpring = web_1.useSpring(function () {
    return {
      from: {
        y: 0
      },
      config: {
        tension: 400,
        mass: 0.8
      }
    };
  }),
      y = _web_1$useSpring[0].y,
      api = _web_1$useSpring[1];

  react_1.useEffect(function () {
    if (!value) {
      return;
    }

    var targetIndex = column.findIndex(function (item) {
      return item.value === value;
    });

    if (targetIndex < 0) {
      return;
    }

    var finalPosition = targetIndex * -itemHeight;
    api.start({
      y: finalPosition,
      immediate: y.idle
    });
  }, [value]);
  react_1.useEffect(function () {
    if (column.length === 0) {
      if (value !== null) {
        props.onSelect(null);
      }
    } else {
      if (!column.some(function (item) {
        return item.value === value;
      })) {
        var firstItem = column[0];
        props.onSelect(firstItem.value);
      }
    }
  });
  var bind = react_use_gesture_1.useDrag(function (state) {
    var min = -((column.length - 1) * itemHeight);
    var max = 0;

    if (state.last) {
      var position = state.movement[1] + state.vxvy[1] * 50;
      var targetIndex = -Math.round(rubberband_1.bound(position, min, max) / itemHeight);
      var finalPosition = targetIndex * -itemHeight;
      api.start({
        y: finalPosition
      });
      onSelect(column[targetIndex].value);
    } else {
      var _position = state.movement[1];
      api.start({
        y: rubberband_1.rubberbandIfOutOfBounds(_position, min, max, itemHeight * 50, 0.2)
      });
    }
  }, {
    axis: 'y',
    initial: function initial() {
      return [0, y.get()];
    },
    filterTaps: true
  });
  return react_1["default"].createElement("div", Object.assign({
    className: classPrefix + "-column"
  }, bind()), react_1["default"].createElement(web_1.animated.div, {
    style: {
      y: y
    },
    className: classPrefix + "-column-wheel"
  }, column.map(function (item, index) {
    function handleClick() {
      var finalPosition = index * -itemHeight;
      api.start({
        y: finalPosition
      });
      onSelect(column[index].value);
    }

    return react_1["default"].createElement("div", {
      key: item.value,
      className: classPrefix + "-column-item",
      onClick: handleClick
    }, react_1["default"].createElement("div", {
      className: classPrefix + "-column-item-label"
    }, item.label));
  })));
};