"use strict";

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importStar(require("react"));

var popup_1 = __importDefault(require("../popup"));

var ahooks_1 = require("ahooks");

var column_1 = require("./column");

var with_default_props_1 = require("../../utils/with-default-props");

var attach_properties_to_component_1 = require("../../utils/attach-properties-to-component");

var cascader_1 = require("./cascader");

var classnames_1 = __importDefault(require("classnames"));

var render_to_body_1 = require("../../utils/render-to-body");

var classPrefix = "am-picker";
var Picker = with_default_props_1.withDefaultProps({
  confirmText: '确定',
  cancelText: '取消'
})(function (props) {
  var controllable = ahooks_1.useControllableValue(props, {
    trigger: 'onConfirm',
    defaultValue: []
  });
  var value = controllable[0];
  var setValue = controllable[1];

  var _react_1$useState = react_1.useState(value),
      innerValue = _react_1$useState[0],
      setInnerValue = _react_1$useState[1];

  react_1.useEffect(function () {
    setInnerValue(value);
  }, [props.visible]);
  var columns = react_1.useMemo(function () {
    var columns = typeof props.columns === 'function' ? props.columns(innerValue) : props.columns;
    return columns.map(function (column) {
      return column.map(function (item) {
        return typeof item === 'string' ? {
          label: item,
          value: item
        } : item;
      });
    });
  }, [props.columns, innerValue]);
  var widget = react_1["default"].createElement(popup_1["default"], {
    visible: props.visible,
    position: 'bottom',
    onMaskClick: function onMaskClick() {
      props.onCancel == null ? void 0 : props.onCancel();
      props.onClose == null ? void 0 : props.onClose();
    },
    getContainer: props.getContainer,
    destroyOnClose: true,
    afterShow: props.afterShow,
    afterClose: props.afterClose
  }, react_1["default"].createElement("div", {
    className: classnames_1["default"](classPrefix, props.className),
    style: props.style
  }, react_1["default"].createElement("div", {
    className: classPrefix + "-header"
  }, react_1["default"].createElement("a", {
    className: classPrefix + "-header-button",
    onClick: function onClick() {
      props.onCancel == null ? void 0 : props.onCancel();
      props.onClose == null ? void 0 : props.onClose();
    }
  }, props.cancelText), react_1["default"].createElement("a", {
    className: classPrefix + "-header-button",
    onClick: function onClick() {
      setValue(innerValue);
      props.onClose == null ? void 0 : props.onClose();
    }
  }, props.confirmText)), react_1["default"].createElement("div", {
    className: classPrefix + "-columns"
  }, columns.map(function (column, index) {
    return react_1["default"].createElement(column_1.Column, {
      key: index,
      column: column,
      value: innerValue[index],
      onSelect: function onSelect(val) {
        setInnerValue(function (prev) {
          var nextValue = [].concat(prev);
          nextValue[index] = val;
          props.onSelect == null ? void 0 : props.onSelect(nextValue);
          return nextValue;
        });
      }
    });
  }), react_1["default"].createElement("div", {
    className: classPrefix + "-mask " + classPrefix + "-mask-top"
  }), react_1["default"].createElement("div", {
    className: classPrefix + "-mask " + classPrefix + "-mask-bottom"
  }))));
  var label = react_1.useMemo(function () {
    if (!props.children) return null;
    var items = columns.map(function (column, index) {
      var _column$find;

      return (_column$find = column.find(function (item) {
        return item.value === value[index];
      })) != null ? _column$find : null;
    });
    return props.children(items);
  }, [value]);
  return react_1["default"].createElement(react_1["default"].Fragment, null, widget, label);
});

function prompt(props) {
  return new Promise(function (resolve) {
    var Wrapper = function Wrapper() {
      var _react_1$useState2 = react_1.useState(false),
          visible = _react_1$useState2[0],
          setVisible = _react_1$useState2[1];

      react_1.useEffect(function () {
        setVisible(true);
      }, []);
      return react_1["default"].createElement(Picker, Object.assign({}, props, {
        visible: visible,
        onConfirm: function onConfirm(val) {
          resolve(val);
        },
        onClose: function onClose() {
          props.onClose == null ? void 0 : props.onClose();
          setVisible(false);
          resolve(null);
        },
        afterClose: function afterClose() {
          props.afterClose == null ? void 0 : props.afterClose();
          unmount();
        }
      }));
    };

    var unmount = render_to_body_1.renderToBody(react_1["default"].createElement(Wrapper, null));
  });
}

function promptCascader(props) {
  return new Promise(function (resolve) {
    var Wrapper = function Wrapper() {
      var _react_1$useState3 = react_1.useState(false),
          visible = _react_1$useState3[0],
          setVisible = _react_1$useState3[1];

      react_1.useEffect(function () {
        setVisible(true);
      }, []);
      return react_1["default"].createElement(cascader_1.Cascader, Object.assign({}, props, {
        visible: visible,
        onConfirm: function onConfirm(val) {
          resolve(val);
        },
        onClose: function onClose() {
          props.onClose == null ? void 0 : props.onClose();
          setVisible(false);
          resolve(null);
        },
        afterClose: function afterClose() {
          props.afterClose == null ? void 0 : props.afterClose();
          unmount();
        }
      }));
    };

    var unmount = render_to_body_1.renderToBody(react_1["default"].createElement(Wrapper, null));
  });
}

exports["default"] = attach_properties_to_component_1.attachPropertiesToComponent(Picker, {
  Cascader: attach_properties_to_component_1.attachPropertiesToComponent(cascader_1.Cascader, {
    prompt: promptCascader
  }),
  prompt: prompt
});