"use strict";

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importStar(require("react"));

var rc_tooltip_1 = __importDefault(require("rc-tooltip"));

var ahooks_1 = require("ahooks");

var button_1 = __importDefault(require("../button"));

var classnames_1 = __importDefault(require("classnames"));

var attach_properties_to_component_1 = require("../../utils/attach-properties-to-component");

var classPrefix = "am-popover";
var enterClassName = 'entering';
var leaveClassName = 'leaving';
var Popover = react_1.forwardRef(function (props, ref) {
  var _props$mode = props.mode,
      mode = _props$mode === void 0 ? 'light' : _props$mode;

  var _ahooks_1$useControll = ahooks_1.useControllableValue(props, {
    valuePropName: 'visible',
    trigger: 'onVisibleChange',
    defaultValuePropName: 'defaultVisible',
    defaultValue: false
  }),
      visible = _ahooks_1$useControll[0],
      onVisibleChange = _ahooks_1$useControll[1];

  react_1.useImperativeHandle(ref, function () {
    return {
      show: function show() {
        return onVisibleChange(true);
      },
      hide: function hide() {
        return onVisibleChange(false);
      },
      visible: visible
    };
  }, [visible]);
  return react_1["default"].createElement(rc_tooltip_1["default"], Object.assign({}, props, {
    overlayClassName: classnames_1["default"](classPrefix + "-" + mode, props.overlayClassName),
    destroyTooltipOnHide: props.destroyOnHide,
    prefixCls: classPrefix,
    getTooltipContainer: props.getContainer || function () {
      return document.body;
    },
    visible: visible,
    onVisibleChange: onVisibleChange,
    trigger: 'click',
    motion: {
      motionName: {
        appear: enterClassName,
        appearActive: enterClassName,
        enter: enterClassName,
        enterActive: enterClassName,
        leaveActive: leaveClassName,
        leave: leaveClassName
      },
      motionDeadline: 200
    },
    overlay: react_1["default"].createElement("div", {
      className: classPrefix + "-inner-content"
    }, props.content)
  }), props.children);
});
var PopMenu = react_1.forwardRef(function (props, ref) {
  var innerRef = react_1.useRef(null);
  react_1.useImperativeHandle(ref, function () {
    return innerRef.current;
  }, []);

  var _onClick = react_1.useCallback(function (e) {
    var _innerRef$current;

    var onSelect = props.onSelect;

    if (onSelect) {
      onSelect(e);
    }

    (_innerRef$current = innerRef.current) == null ? void 0 : _innerRef$current.hide();
  }, [props.onSelect]);

  var overlay = react_1.useMemo(function () {
    return react_1["default"].createElement(react_1["default"].Fragment, null, (props.actions || []).map(function (ele, index) {
      var _classnames_1$default, _ele$key;

      return react_1["default"].createElement("div", {
        className: classnames_1["default"](classPrefix + "-inner-menu", (_classnames_1$default = {}, _classnames_1$default[classPrefix + "-inner-menu-with-icon"] = !!ele.icon, _classnames_1$default)),
        key: (_ele$key = ele.key) != null ? _ele$key : index
      }, react_1["default"].createElement(button_1["default"], {
        disabled: ele.disabled,
        onClick: function onClick() {
          if (!ele.disabled) {
            _onClick(ele);
          }
        },
        fill: 'none',
        block: true
      }, ele.icon && react_1["default"].createElement("span", {
        className: classPrefix + "-inner-menu-icon"
      }, ele.icon), ele.text));
    }));
  }, [props.actions, _onClick]);
  return react_1["default"].createElement(Popover, Object.assign({
    ref: innerRef
  }, props, {
    overlayClassName: classnames_1["default"](classPrefix + "-menu", props.overlayClassName),
    content: overlay
  }), props.children);
});
exports["default"] = attach_properties_to_component_1.attachPropertiesToComponent(Popover, {
  Menu: PopMenu
});