"use strict";

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var classnames_1 = __importDefault(require("classnames"));

var react_1 = __importStar(require("react"));

var react_transition_group_1 = require("react-transition-group");

var use_initialized_1 = require("../../utils/use-initialized");

var with_default_props_1 = require("../../utils/with-default-props");

var mask_1 = __importDefault(require("../mask"));

var use_lock_scroll_1 = require("../../utils/use-lock-scroll");

var render_to_container_1 = require("../../utils/render-to-container");

var classPrefix = "am-popup";
var defaultProps = {
  position: 'bottom',
  visible: false,
  getContainer: function getContainer() {
    return document.body;
  },
  mask: true
};

var Popup = function Popup(p) {
  var _classnames_1$default, _classnames_1$default2;

  var props = with_default_props_1.mergeProps(defaultProps, p); // 动画执行完，才隐藏最外层

  var _react_1$useState = react_1.useState(!props.visible),
      hidden = _react_1$useState[0],
      setHidden = _react_1$useState[1];

  react_1.useEffect(function () {
    if (props.visible) {
      setHidden(false);
    }
  }, [props.visible]);

  var afterClose = function afterClose() {
    setHidden(true);
    props.afterClose == null ? void 0 : props.afterClose();
  };

  var cls = classnames_1["default"](classPrefix, props.className, (_classnames_1$default = {}, _classnames_1$default[classPrefix + "-hidden"] = hidden, _classnames_1$default));
  var bodyCls = classnames_1["default"](classPrefix + "-body", props.bodyClassName, (_classnames_1$default2 = {}, _classnames_1$default2[classPrefix + "-body-hidden"] = !props.visible, _classnames_1$default2), classPrefix + "-body-position-" + props.position);
  var initialized = use_initialized_1.useInitialized(props.visible || props.forceRender);
  var ref = react_1.useRef(null);
  use_lock_scroll_1.useLockScroll(ref, props.visible);
  var node = react_1["default"].createElement("div", {
    className: cls,
    style: props.style
  }, props.mask && react_1["default"].createElement(mask_1["default"], {
    visible: props.visible,
    onMaskClick: props.onMaskClick,
    className: props.maskClassName,
    style: props.maskStyle,
    disableBodyScroll: false
  }), react_1["default"].createElement(react_transition_group_1.CSSTransition, {
    classNames: classPrefix + "-body",
    "in": props.visible,
    timeout: 200,
    onEntered: props.afterShow,
    onExited: afterClose,
    unmountOnExit: props.destroyOnClose
  }, react_1["default"].createElement("div", {
    className: bodyCls,
    style: props.bodyStyle,
    ref: ref
  }, initialized && props.children)));
  return render_to_container_1.renderToContainer(props.getContainer, node);
};

exports["default"] = Popup;