"use strict";

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importStar(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var ahooks_1 = require("ahooks");

var icons_1 = require("@ant-design/icons");

var group_1 = require("./group");

var group_context_1 = require("./group-context");

var attach_properties_to_component_1 = require("../../utils/attach-properties-to-component");

var classPrefix = "am-radio";

var Radio = function Radio(props) {
  var _classnames_1$default;

  var groupContext = react_1.useContext(group_context_1.RadioGroupContext);

  var _ahooks_1$useControll = ahooks_1.useControllableValue(props, {
    valuePropName: 'checked',
    defaultValuePropName: 'defaultChecked',
    defaultValue: false
  }),
      checked = _ahooks_1$useControll[0],
      setChecked = _ahooks_1$useControll[1];

  var disabled = props.disabled;
  var value = props.value;

  if (groupContext && value) {
    checked = groupContext.value.includes(value);

    setChecked = function setChecked(checked) {
      if (checked) {
        groupContext.check(value);
      } else {
        groupContext.uncheck(value);
      }

      props.onChange == null ? void 0 : props.onChange(checked);
    };

    disabled = disabled || groupContext.disabled;
  }

  return react_1["default"].createElement("label", {
    className: classnames_1["default"](classPrefix, props.className, (_classnames_1$default = {}, _classnames_1$default[classPrefix + "-checked"] = checked, _classnames_1$default[classPrefix + "-disabled"] = disabled, _classnames_1$default)),
    style: props.style
  }, react_1["default"].createElement("input", {
    type: 'radio',
    checked: checked,
    onChange: function onChange(e) {
      setChecked(e.target.checked);
    },
    onClick: function onClick(e) {
      e.stopPropagation();
      e.nativeEvent.stopImmediatePropagation();
    },
    disabled: disabled
  }), react_1["default"].createElement("div", {
    className: classPrefix + "-icon"
  }, react_1["default"].createElement(icons_1.CheckOutlined, {
    className: classPrefix + "-icon-checked"
  })), props.children && react_1["default"].createElement("div", {
    className: classPrefix + "-content"
  }, props.children));
};

exports["default"] = attach_properties_to_component_1.attachPropertiesToComponent(Radio, {
  Group: group_1.Group
});