"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var with_default_props_1 = require("../../utils/with-default-props");

var icons_1 = require("@ant-design/icons");

var ahooks_1 = require("ahooks");

var classPrefix = "am-rate";
var defaultProps = {
  count: 5,
  allowHalf: false,
  character: react_1["default"].createElement(icons_1.StarFilled, null),
  defaultValue: 0,
  readonly: false,
  allowClear: true
};
var Rate = with_default_props_1.withDefaultProps(defaultProps)(function (props) {
  var _ahooks_1$useControll = ahooks_1.useControllableValue(props),
      value = _ahooks_1$useControll[0],
      setValue = _ahooks_1$useControll[1];

  var starList = Array(props.count).fill(null);

  function renderStar(v, half) {
    var _classnames_1$default;

    return react_1["default"].createElement("div", {
      className: classnames_1["default"](classPrefix + "-star", (_classnames_1$default = {}, _classnames_1$default[classPrefix + "-star-active"] = value >= v, _classnames_1$default[classPrefix + "-star-half"] = half, _classnames_1$default[classPrefix + "-star-readonly"] = props.readonly, _classnames_1$default)),
      onClick: function onClick() {
        if (props.readonly) return;

        if (props.allowClear && value === v) {
          setValue(0);
        } else {
          setValue(v);
        }
      }
    }, props.character);
  }

  return react_1["default"].createElement("div", {
    style: props.style,
    className: classnames_1["default"](classPrefix, props.className)
  }, starList.map(function (_, i) {
    return react_1["default"].createElement("div", {
      key: i,
      className: classnames_1["default"](classPrefix + "-box")
    }, props.allowHalf && renderStar(i + 0.5, true), renderStar(i + 1, false));
  }));
});
exports["default"] = Rate;