"use strict";

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importStar(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var input_1 = __importDefault(require("../input"));

var with_default_props_1 = require("../../utils/with-default-props");

var icons_1 = require("@ant-design/icons");

var ahooks_1 = require("ahooks");

var classPrefix = "am-search";
var defaultProps = {
  clearable: true,
  showCancelButton: false
};
var Search = with_default_props_1.withDefaultProps(defaultProps)(function (props) {
  var _classnames_1$default;

  var _ahooks_1$useControll = ahooks_1.useControllableValue(props, {
    defaultValue: ''
  }),
      value = _ahooks_1$useControll[0],
      setValue = _ahooks_1$useControll[1];

  var _react_1$useState = react_1.useState(false),
      hasFocus = _react_1$useState[0],
      setHasFocus = _react_1$useState[1];

  var inputRef = react_1.useRef(null);
  return react_1["default"].createElement("div", {
    className: classnames_1["default"](classPrefix, props.className, (_classnames_1$default = {}, _classnames_1$default[classPrefix + "-active"] = hasFocus, _classnames_1$default)),
    style: props.style
  }, react_1["default"].createElement("form", {
    className: classPrefix + "-input-box",
    action: '/',
    onSubmit: function onSubmit(e) {
      var _inputRef$current;

      e.preventDefault();
      e.stopPropagation();
      (_inputRef$current = inputRef.current) == null ? void 0 : _inputRef$current.blur();
      props.onSearch == null ? void 0 : props.onSearch(value);
    }
  }, react_1["default"].createElement("div", {
    className: classPrefix + "-input-box-icon"
  }, react_1["default"].createElement(icons_1.SearchOutlined, null)), react_1["default"].createElement(input_1["default"], {
    ref: inputRef,
    className: classPrefix + "-input",
    value: value,
    onChange: setValue,
    maxLength: props.maxLength,
    placeholder: props.placeholder,
    clearable: props.clearable,
    onFocus: function onFocus() {
      setHasFocus(true);
      props.onFocus == null ? void 0 : props.onFocus();
    },
    onBlur: function onBlur() {
      setHasFocus(false);
      props.onBlur == null ? void 0 : props.onBlur();
    },
    onClear: props.onClear,
    type: 'search'
  })), props.showCancelButton && hasFocus && react_1["default"].createElement("div", {
    className: classPrefix + "-suffix"
  }, react_1["default"].createElement("a", {
    onMouseDown: function onMouseDown(e) {
      e.preventDefault();
    },
    onTouchStart: function onTouchStart(e) {
      e.preventDefault();
    },
    onClick: function onClick() {
      var _inputRef$current2, _inputRef$current3;

      (_inputRef$current2 = inputRef.current) == null ? void 0 : _inputRef$current2.clear();
      (_inputRef$current3 = inputRef.current) == null ? void 0 : _inputRef$current3.blur();
      props.onCancel == null ? void 0 : props.onCancel();
    }
  }, "\u53D6\u6D88")));
});
exports["default"] = Search;