"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var classPrefix = "am-slider-mark";

var Marks = function Marks(_ref) {
  var marks = _ref.marks,
      upperBound = _ref.upperBound,
      lowerBound = _ref.lowerBound,
      max = _ref.max,
      min = _ref.min;
  var marksKeys = Object.keys(marks);
  var range = max - min;
  var elements = marksKeys.map(parseFloat).sort(function (a, b) {
    return a - b;
  }).filter(function (point) {
    return point >= min && point <= max;
  }).map(function (point) {
    var _classnames_1$default;

    var markPoint = marks[point];

    if (!markPoint && markPoint !== 0) {
      return null;
    }

    var isActive = point <= upperBound && point >= lowerBound;
    var markClassName = classnames_1["default"]((_classnames_1$default = {}, _classnames_1$default[classPrefix + "-text"] = true, _classnames_1$default[classPrefix + "-text-active"] = isActive, _classnames_1$default));
    var style = {
      left: (point - min) / range * 100 + "%"
    };
    return react_1["default"].createElement("span", {
      className: markClassName,
      style: style,
      key: point
    }, markPoint);
  });
  return react_1["default"].createElement("div", {
    className: classPrefix
  }, elements);
};

exports["default"] = Marks;