"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var classPrefix = "am-slider";

var Ticks = function Ticks(_ref) {
  var points = _ref.points,
      max = _ref.max,
      min = _ref.min,
      upperBound = _ref.upperBound,
      lowerBound = _ref.lowerBound;
  var range = max - min;
  var elements = points.map(function (point) {
    var _classnames_1$default;

    var offset = Math.abs(point - min) / range * 100 + "%";
    var isActived = point <= upperBound && point >= lowerBound;
    var style = {
      left: offset
    };
    var pointClassName = classnames_1["default"]((_classnames_1$default = {}, _classnames_1$default[classPrefix + "-tick"] = true, _classnames_1$default[classPrefix + "-tick-active"] = isActived, _classnames_1$default));
    return react_1["default"].createElement("span", {
      className: pointClassName,
      style: style,
      key: point
    });
  });
  return react_1["default"].createElement("div", {
    className: classPrefix + "-ticks"
  }, elements);
};

exports["default"] = Ticks;