"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var step_1 = __importDefault(require("./step"));

var with_default_props_1 = require("../../utils/with-default-props");

var attach_properties_to_component_1 = require("../../utils/attach-properties-to-component");

var classPrefix = "am-steps";
var stepClassPrefix = "am-step";
var defaultIcon = react_1["default"].createElement("span", {
  className: stepClassPrefix + "-icon-dot"
});
var defaultProps = {
  current: 0,
  direction: 'horizontal'
};
var Steps = with_default_props_1.withDefaultProps(defaultProps)(function (props) {
  var direction = props.direction,
      current = props.current;
  var classString = classnames_1["default"](classPrefix, classPrefix + "-" + direction);
  return react_1["default"].createElement("div", {
    className: classString
  }, react_1["default"].Children.map(props.children, function (child, index) {
    var _props$icon;

    if (!react_1["default"].isValidElement(child)) {
      return child;
    }

    var props = child.props;
    var status = props.status || 'wait';

    if (index < current) {
      status = props.status || 'finish';
    } else if (index === current) {
      status = props.status || 'process';
    }

    var icon = (_props$icon = props.icon) != null ? _props$icon : defaultIcon;
    return react_1["default"].cloneElement(child, {
      status: status,
      icon: icon
    });
  }));
});
exports["default"] = attach_properties_to_component_1.attachPropertiesToComponent(Steps, {
  Step: step_1["default"]
});