"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var ahooks_1 = require("ahooks");

var classnames_1 = __importDefault(require("classnames"));

var react_1 = __importDefault(require("react"));

var spin_svg_1 = __importDefault(require("../../assets/spin.svg"));

var classPrefix = "am-switch";

var Switch = function Switch(props) {
  var _classnames_1$default;

  var disabled = props.disabled || props.loading || false;

  var _ahooks_1$useControll = ahooks_1.useControllableValue(props, {
    valuePropName: 'checked',
    defaultValuePropName: 'defaultChecked',
    defaultValue: false
  }),
      checked = _ahooks_1$useControll[0],
      setChecked = _ahooks_1$useControll[1];

  return react_1["default"].createElement("label", {
    className: classnames_1["default"](classPrefix, (_classnames_1$default = {}, _classnames_1$default[classPrefix + "-checked"] = checked, _classnames_1$default[classPrefix + "-disabled"] = disabled, _classnames_1$default), props.className),
    style: props.style
  }, react_1["default"].createElement("input", {
    type: 'checkbox',
    checked: checked,
    onChange: function onChange(e) {
      disabled || setChecked(e.target.checked);
    },
    disabled: disabled
  }), react_1["default"].createElement("div", {
    className: classPrefix + "-checkbox"
  }, react_1["default"].createElement("div", {
    className: classPrefix + "-handle"
  }, // 禁用状态优先于加载状态
  props.disabled || props.loading && react_1["default"].createElement("img", {
    src: spin_svg_1["default"],
    className: classPrefix + "-icon"
  }))));
};

exports["default"] = Switch;