"use strict";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importStar(require("react"));

var react_dom_1 = __importDefault(require("react-dom"));

var classnames_1 = __importDefault(require("classnames"));

var icons_1 = require("@ant-design/icons");

var ahooks_1 = require("ahooks");

var noop_1 = require("../../utils/noop");

var loading_1 = __importDefault(require("../loading"));

var mask_1 = __importDefault(require("../mask"));

var get_container_1 = require("../../utils/get-container");

var classPrefix = "am-toast";
var toastArray = [];

var InternalToast = function InternalToast(props) {
  var _props$maskClickable = props.maskClickable,
      maskClickable = _props$maskClickable === void 0 ? true : _props$maskClickable,
      content = props.content,
      _props$icon = props.icon,
      icon = _props$icon === void 0 ? null : _props$icon,
      position = props.position;
  var top = react_1.useMemo(function () {
    switch (position) {
      case 'top':
        return '20%';

      case 'bottom':
        return '80%';

      default:
        return '50%';
    }
  }, [position]);
  return react_1["default"].createElement(mask_1["default"], {
    visible: props.visible,
    destroyOnClose: true,
    opacity: 0,
    disableBodyScroll: !maskClickable,
    getContainer: props.getContainer,
    afterClose: props.afterClose,
    style: _extends({
      pointerEvents: maskClickable ? 'none' : 'all'
    }, props.maskStyle),
    className: classnames_1["default"](classPrefix + "-mask", props.maskClassName)
  }, react_1["default"].createElement("div", {
    style: {
      top: top
    },
    className: classnames_1["default"](classPrefix + "-wrap", icon ? classPrefix + "-wrap-icon" : classPrefix + "-wrap-text")
  }, Boolean(icon) && react_1["default"].createElement("div", {
    className: classPrefix + "-icon"
  }, icon), content));
}; // 可返回用于销毁此弹窗的方法


function show(props) {
  var updateConfig = function updateConfig() {};

  var timer = 0;
  var _props$afterClose = props.afterClose,
      afterClose = _props$afterClose === void 0 ? noop_1.noop : _props$afterClose,
      _props$getContainer = props.getContainer,
      getContainer = _props$getContainer === void 0 ? function () {
    return document.body;
  } : _props$getContainer;
  var container = document.createElement('div');
  var bodyContainer = get_container_1.resolveContainer(getContainer);
  bodyContainer.appendChild(container);

  var TempToast = function TempToast() {
    var _react_1$useState = react_1.useState(true),
        visible = _react_1$useState[0],
        setVisible = _react_1$useState[1];

    var _react_1$useState2 = react_1.useState(_extends({
      duration: 2000
    }, props)),
        state = _react_1$useState2[0],
        setState = _react_1$useState2[1]; // clearDOM after animation


    var _afterClose = function _afterClose() {
      afterClose();
      var unmountResult = react_dom_1["default"].unmountComponentAtNode(container);

      if (unmountResult && container.parentNode) {
        container.parentNode.removeChild(container);
      }
    }; // close with animation


    var destroy = react_1.useCallback(function () {
      setVisible(false);
    }, []);
    react_1.useEffect(function () {
      _clear();

      toastArray.push(_afterClose);
    }, []);
    updateConfig = react_1.useCallback(function (nextState) {
      return setState(function (prev) {
        return typeof nextState === 'function' ? _extends({}, prev, nextState(prev)) : _extends({}, prev, nextState);
      });
    }, [setState]);
    react_1.useEffect(function () {
      if (state.duration !== 0 && 'duration' in state) {
        timer = window.setTimeout(destroy, state.duration);
      }

      return function () {
        if (timer !== 0) {
          window.clearTimeout(timer);
        }
      };
    }, []); // 当修改 duration 时，重新计时

    ahooks_1.useUpdateEffect(function () {
      if ('duration' in state) {
        window.clearTimeout(timer);
        timer = window.setTimeout(destroy, state.duration);
      }
    }, [state.duration]);
    return react_1["default"].createElement(InternalToast, Object.assign({}, state, {
      getContainer: function getContainer() {
        return container;
      },
      visible: visible,
      afterClose: _afterClose
    }));
  };

  react_dom_1["default"].render(react_1["default"].createElement(TempToast, null), container);
  return updateConfig;
}

function success(props) {
  return show(_extends({
    icon: react_1["default"].createElement(icons_1.CheckOutlined, null)
  }, props));
}

function fail(props) {
  return show(_extends({
    icon: react_1["default"].createElement(icons_1.CloseOutlined, null)
  }, props));
}

function loading(props) {
  return show(_extends({
    icon: react_1["default"].createElement(loading_1["default"], {
      color: 'white'
    })
  }, props));
} // 同步的销毁


function _clear() {
  var fn = toastArray.pop();

  while (fn) {
    fn();
    fn = toastArray.pop();
  }
} // 针对 toast 还没弹出来就立刻销毁的情况，将销毁放到下一个 event loop 中，避免销毁失败。


function clear() {
  setTimeout(_clear);
}

var Toast = {
  show: show,
  success: success,
  fail: fail,
  loading: loading,
  clear: clear
};
exports["default"] = Toast;