"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mergeProps = exports.withDefaultProps = void 0;

var assign_1 = __importDefault(require("lodash/assign"));

var assignWith_1 = __importDefault(require("lodash/assignWith"));

var isUndefined_1 = __importDefault(require("lodash/isUndefined"));

function withDefaultProps(defaultProps) {
  return function (C) {
    C.defaultProps = defaultProps;
    return C;
  };
}

exports.withDefaultProps = withDefaultProps;

function mergeProps(defaultProps, props) {
  function customizer(objValue, srcValue) {
    return isUndefined_1["default"](srcValue) ? objValue : srcValue;
  }

  return assignWith_1["default"](assign_1["default"]({}, defaultProps), props, customizer);
}

exports.mergeProps = mergeProps;