import React from 'react';
import classNames from 'classnames';
var classPrefix = "am-card";

var Card = function Card(props) {
  var renderHeader = function renderHeader() {
    if (!(props.title || props.extra)) {
      return null;
    }

    return /*#__PURE__*/React.createElement("div", {
      className: classNames(classPrefix + "-header"),
      onClick: props.onHeaderClick
    }, /*#__PURE__*/React.createElement("div", {
      className: classPrefix + "-header-title"
    }, props.title), props.extra);
  };

  var renderBody = function renderBody() {
    if (!props.children) {
      return null;
    }

    return /*#__PURE__*/React.createElement("div", {
      className: classPrefix + "-body",
      onClick: props.onBodyClick
    }, props.children);
  };

  return /*#__PURE__*/React.createElement("div", {
    className: classNames(classPrefix, props.className),
    onClick: props.onClick,
    style: props.style
  }, renderHeader(), renderBody());
};

export default Card;