import React from 'react';
import { useControllableValue } from 'ahooks';
import classnames from 'classnames';
import { withDefaultProps } from '../../utils/with-default-props';
import EyeIcon from '../../assets/eye.svg';
import EyeCloseIcon from '../../assets/eye-close.svg';
var classPrefix = "am-desens-text";
var DesensText = withDefaultProps({
  defaultDesens: true
})(function (props) {
  var text = props.text,
      desensText = props.desensText;

  var _useControllableValue = useControllableValue(props, {
    valuePropName: 'desens',
    defaultValuePropName: 'defaultDesens'
  }),
      isDesens = _useControllableValue[0],
      setIsDesens = _useControllableValue[1];

  return /*#__PURE__*/React.createElement("span", {
    className: classnames(classPrefix, props.className),
    style: props.style
  }, isDesens ? desensText : text, /*#__PURE__*/React.createElement("span", {
    className: classPrefix + "-icon-wrap",
    onClick: function onClick() {
      setIsDesens(!isDesens);
    }
  }, /*#__PURE__*/React.createElement("img", {
    src: isDesens ? EyeCloseIcon : EyeIcon,
    className: classPrefix + "-icon"
  })));
});
export default DesensText;