var _excluded = ["afterClose", "onCancel", "onOk", "cancelProps", "okProps"];

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _await(value, then, direct) {
  if (direct) {
    return then ? then(value) : value;
  }

  if (!value || !value.then) {
    value = Promise.resolve(value);
  }

  return then ? value.then(then) : value;
}

function _async(f) {
  return function () {
    for (var args = [], i = 0; i < arguments.length; i++) {
      args[i] = arguments[i];
    }

    try {
      return Promise.resolve(f.apply(this, args));
    } catch (e) {
      return Promise.reject(e);
    }
  };
}

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useState } from 'react';
import ReactDOM from 'react-dom';
import classNames from 'classnames';
import { noop } from '../../utils/noop';
import { resolveContainer } from '../../utils/get-container';
import Button from '../button';
import Mask from '../mask';
var classPrefix = "am-dialog";

var InternalDialog = function InternalDialog(props) {
  var _props$cancelProps, _classNames, _props$cancelProps2, _props$cancelProps3, _props$cancelProps4, _props$okProps, _props$okProps2, _props$okProps3;

  return /*#__PURE__*/React.createElement(Mask, {
    visible: props.visible,
    destroyOnClose: true,
    getContainer: props.getContainer,
    afterClose: props.afterClose,
    onMaskClick: props.maskClosable && !((_props$cancelProps = props.cancelProps) != null && _props$cancelProps.loading) ? props.onCancel : noop,
    style: props.maskStyle,
    className: classNames(classPrefix + "-mask", props.maskClassName)
  }, /*#__PURE__*/React.createElement("div", {
    onClick: function onClick(e) {
      return e.stopPropagation();
    },
    className: classPrefix + "-wrap"
  }, Boolean(props.headerImage) && /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-image"
  }, /*#__PURE__*/React.createElement("img", {
    src: props.headerImage,
    alt: 'inside dialog'
  })), /*#__PURE__*/React.createElement("div", {
    style: props.bodyStyle,
    className: classNames(classPrefix + "-body", props.bodyClassName)
  }, Boolean(props.title) && /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-body-title"
  }, props.title), Boolean(props.content) && /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-body-message-wrapper"
  }, /*#__PURE__*/React.createElement("div", {
    className: classNames(classPrefix + "-body-message", (_classNames = {}, _classNames[classPrefix + "-body-message-with-title"] = !!props.title, _classNames))
  }, props.content))), /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-footer"
  }, /*#__PURE__*/React.createElement(Button, {
    onClick: (_props$cancelProps2 = props.cancelProps) != null && _props$cancelProps2.loading ? noop : props.onCancel,
    className: classPrefix + "-btn-cancel",
    fill: 'none',
    block: true,
    loading: (_props$cancelProps3 = props.cancelProps) == null ? void 0 : _props$cancelProps3.loading,
    disabled: (_props$cancelProps4 = props.cancelProps) == null ? void 0 : _props$cancelProps4.disabled
  }, props.cancelText || (props.okText ? '取消' : '我知道了')), Boolean(props.okText) && /*#__PURE__*/React.createElement(Button, {
    onClick: (_props$okProps = props.okProps) != null && _props$okProps.loading ? noop : props.onOk,
    loading: (_props$okProps2 = props.okProps) == null ? void 0 : _props$okProps2.loading,
    fill: 'none',
    block: true,
    disabled: (_props$okProps3 = props.okProps) == null ? void 0 : _props$okProps3.disabled,
    className: classPrefix + "-btn-ok"
  }, props.okText || '确认'))));
};

var Dialog = {}; // 可返回用于销毁此弹窗的方法

Dialog.show = function (props) {
  var afterClose = props.afterClose,
      _props$onCancel = props.onCancel,
      onCancel = _props$onCancel === void 0 ? noop : _props$onCancel,
      _props$onOk = props.onOk,
      onOk = _props$onOk === void 0 ? noop : _props$onOk,
      cancelProps = props.cancelProps,
      okProps = props.okProps,
      restProps = _objectWithoutPropertiesLoose(props, _excluded);

  var userContainer = resolveContainer(props.getContainer);
  var container = document.createElement('div');
  userContainer.appendChild(container);
  var destroy = noop;

  var TempDialog = function TempDialog() {
    var _useState = useState(false),
        cancelLoading = _useState[0],
        setCancelLoading = _useState[1];

    var _useState2 = useState(false),
        okLoading = _useState2[0],
        setOkLoading = _useState2[1];

    var _useState3 = useState(true),
        visible = _useState3[0],
        setVisible = _useState3[1];

    destroy = function destroy() {
      setVisible(false);

      if (afterClose) {
        afterClose();
      }
    };

    var _afterClose = function _afterClose() {
      var unmountResult = ReactDOM.unmountComponentAtNode(container);

      if (unmountResult && container.parentNode) {
        container.parentNode.removeChild(container);
      }
    };

    var _onOk = _async(function (e) {
      var i = setTimeout(function () {
        return setOkLoading(true);
      });
      return _await(onOk(e), function (_onOk2) {
        if (_onOk2 !== false) {
          clearTimeout(i);
          destroy();
        } else {
          clearTimeout(i);
          setOkLoading(false);
        }
      });
    });

    var _onCancel = _async(function (e) {
      var i = setTimeout(function () {
        return setCancelLoading(true);
      });
      return _await(onCancel(e), function (_onCancel2) {
        if (_onCancel2 !== false) {
          clearTimeout(i);
          destroy();
        } else {
          clearTimeout(i);
          setCancelLoading(false);
        }
      });
    });

    return /*#__PURE__*/React.createElement(InternalDialog, Object.assign({}, restProps, {
      visible: visible,
      getContainer: function getContainer() {
        return container;
      },
      cancelProps: _extends({
        loading: cancelLoading
      }, cancelProps),
      okProps: _extends({
        loading: okLoading
      }, okProps),
      onCancel: _onCancel,
      onOk: _onOk,
      afterClose: _afterClose
    }));
  };

  if (props.headerImage && props.waitImageLoad !== false) {
    var preloadImage = new Image();
    preloadImage.src = props.headerImage;

    preloadImage.onload = function () {
      ReactDOM.render( /*#__PURE__*/React.createElement(TempDialog, null), container);
    };
  } else {
    ReactDOM.render( /*#__PURE__*/React.createElement(TempDialog, null), container);
  }

  return destroy;
}; // 可使用 async/await 的方式


Dialog.alert = function (props) {
  var _props$onCancel2 = props.onCancel,
      _onCancel3 = _props$onCancel2 === void 0 ? noop : _props$onCancel2;

  return new Promise(function (resolve) {
    Dialog.show(_extends({}, props, {
      // 强制不现实 OK Btn
      okText: undefined,
      onOk: noop,
      onCancel: function onCancel(e) {
        _onCancel3(e);

        resolve(e);
      }
    }));
  });
};

Dialog.confirm = function (props) {
  var _props$onCancel3 = props.onCancel,
      _onCancel4 = _props$onCancel3 === void 0 ? noop : _props$onCancel3,
      _props$onOk2 = props.onOk,
      _onOk3 = _props$onOk2 === void 0 ? noop : _props$onOk2;

  return new Promise(function (resolve) {
    Dialog.show(_extends({
      // 强制显示 OK Btn
      okText: '确认'
    }, props, {
      onCancel: function onCancel(e) {
        _onCancel4(e);

        resolve(false);
      },
      onOk: function onOk(e) {
        _onOk3(e);

        resolve(true);
      }
    }));
  });
};

export default Dialog;