function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import { useClickAway, useControllableValue } from 'ahooks';
import classNames from 'classnames';
import React, { cloneElement, useEffect, useRef, useState } from 'react';
import Popup from '../popup';
import Item from './item';
var classPrefix = "am-dropdown";

var Dropdown = function Dropdown(props) {
  var _classNames;

  var _useControllableValue = useControllableValue(props, {
    valuePropName: 'activeKey'
  }),
      value = _useControllableValue[0],
      onChange = _useControllableValue[1];

  var navRef = useRef(null);
  var contentRef = useRef(null); // 点击外部区域，关闭

  useClickAway(function () {
    onChange(undefined);
  }, [navRef, contentRef]); // 计算 navs 的 top 值

  var _useState = useState(),
      top = _useState[0],
      setTop = _useState[1];

  var containerRef = useRef(null);
  useEffect(function () {
    if (value) {
      var rect = containerRef.current.getBoundingClientRect();
      setTop(rect.bottom);
    }
  }, [value]);

  var changeActive = function changeActive(key) {
    if (value === key) {
      onChange(undefined);
    } else {
      onChange(key);
    }
  };

  var contents = {};
  var navs = React.Children.map(props.children, function (child) {
    if ( /*#__PURE__*/React.isValidElement(child)) {
      var childProps = _extends({}, child.props, {
        onClick: function onClick() {
          changeActive(child.key);
        },
        active: child.key === value
      });

      contents[child.key] = child.props.children;
      return /*#__PURE__*/cloneElement(child, childProps);
    } else {
      return child;
    }
  });
  return /*#__PURE__*/React.createElement("div", {
    className: classNames(classPrefix, props.className, (_classNames = {}, _classNames[classPrefix + "-open"] = !!value, _classNames)),
    style: props.style,
    ref: containerRef
  }, /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-nav",
    ref: navRef
  }, navs), /*#__PURE__*/React.createElement(Popup, {
    visible: !!value,
    position: 'top',
    className: classPrefix + "-popup",
    maskClassName: classPrefix + "-popup-mask",
    bodyClassName: classPrefix + "-popup-body",
    style: {
      top: top
    },
    forceRender: props.forceRender
  }, /*#__PURE__*/React.createElement("div", {
    ref: contentRef
  }, Object.keys(contents).map(function (key) {
    var _classNames2;

    var isActive = key === value;
    var cls = classNames(classPrefix + "-content", (_classNames2 = {}, _classNames2[classPrefix + "-content-hidden"] = !isActive, _classNames2));

    if (!props.forceRender && !isActive) {
      return null;
    }

    return /*#__PURE__*/React.createElement("div", {
      className: cls,
      key: key
    }, contents[key]);
  }))));
};

Dropdown.Item = Item;
export default Dropdown;