import React from 'react';
import classNames from 'classnames';
import { errorConfigRecord } from './error';
import { withDefaultProps } from '../../utils/with-default-props';
var classPrefix = "am-error";
var defaultProps = {
  status: 'default'
};
var Error = withDefaultProps(defaultProps)(function (props) {
  var _classNames;

  var config = errorConfigRecord[props.status];
  var des = 'description' in props ? props.description : config.description;
  var title = 'title' in props ? props.title : config.title;
  var imageNode = /*#__PURE__*/React.createElement("img", {
    src: config.icon
  });

  if (props.image) {
    if (typeof props.image === 'string') {
      imageNode = /*#__PURE__*/React.createElement("img", {
        src: props.image
      });
    } else {
      imageNode = props.image;
    }
  }

  return /*#__PURE__*/React.createElement("div", {
    className: classNames(classPrefix, props.className, (_classNames = {}, _classNames[classPrefix + "-full-page"] = props.fullPage, _classNames)),
    style: props.style
  }, /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-image"
  }, imageNode), /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-description"
  }, title && /*#__PURE__*/React.createElement("span", {
    className: classPrefix + "-description-title"
  }, title), des && /*#__PURE__*/React.createElement("span", {
    className: classPrefix + "-description-subtitle"
  }, des)), props.children && /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-content"
  }, props.children));
});
export default Error;