var _excluded = ["className", "style", "hasFeedback", "children"];

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import classNames from 'classnames';
import RcForm from 'rc-field-form';
import { FormContext, DEFAULT_FORM_CONTEXT } from './context';
var classPrefix = "am-form";
export var Form = function Form(props) {
  var className = props.className,
      style = props.style,
      hasFeedback = props.hasFeedback,
      children = props.children,
      formProps = _objectWithoutPropertiesLoose(props, _excluded);

  var formClassName = classNames(classPrefix, className);
  return /*#__PURE__*/React.createElement(RcForm, Object.assign({
    className: formClassName,
    style: style
  }, formProps), /*#__PURE__*/React.createElement(FormContext.Provider, {
    value: {
      hasFeedback: hasFeedback || DEFAULT_FORM_CONTEXT.hasFeedback
    }
  }, children));
};