function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import { withDefaultProps } from '../../utils/with-default-props';
import { attachPropertiesToComponent } from '../../utils/attach-properties-to-component';
import React from 'react';
import classNames from 'classnames';
var classPrefix = "am-grid";
var defaultProps = {
  gap: 0
};
var Grid = withDefaultProps(defaultProps)(function (props) {
  var gapStyle = {};

  if (props.style) {
    gapStyle = _extends({}, gapStyle, props.style);
  }

  var gap = props.gap;

  if (gap) {
    var _ref = Array.isArray(gap) ? gap : [gap, gap],
        horizontalGap = _ref[0],
        verticalGap = _ref[1];

    gapStyle = _extends({}, gapStyle, {
      '--vertical-gap': typeof verticalGap === 'number' ? verticalGap + "px" : verticalGap,
      '--horizontal-gap': typeof horizontalGap === 'number' ? horizontalGap + "px" : horizontalGap
    });
  }

  return /*#__PURE__*/React.createElement("div", {
    className: classNames("" + classPrefix, props.className),
    style: _extends({}, gapStyle, {
      '--columns': props.columns
    })
  }, props.children);
});
var GridItem = withDefaultProps({
  span: 1
})(function (props) {
  var _props$style;

  var itemStyle = (_props$style = props.style) != null ? _props$style : {};
  itemStyle = _extends({}, itemStyle, {
    '--item-span': props.span
  });
  return /*#__PURE__*/React.createElement("div", {
    className: classNames(classPrefix + "-item", props.className),
    style: itemStyle
  }, props.children);
});
export default attachPropertiesToComponent(Grid, {
  Item: GridItem
});