import { GetContainer } from '../../utils/render-to-container';
import React from 'react';
export declare type ImageViewerProps = {
    image?: string;
    maxZoom?: number;
    getContainer?: GetContainer;
    visible?: boolean;
    onClose?: () => void;
    afterClose?: () => void;
};
export declare type MultiImageViewerProps = Omit<ImageViewerProps, 'image'> & {
    images?: string[];
    defaultIndex?: number;
    onIndexChange?: (index: number) => void;
};
declare function showImageViewer(props: Omit<ImageViewerProps, 'visible'>): {
    close: () => void;
};
declare function showMultiImageViewer(props: Omit<MultiImageViewerProps, 'visible'>): {
    close: () => void;
};
declare const _default: React.FC<ImageViewerProps> & {
    Multi: React.FC<MultiImageViewerProps> & {
        show: typeof showMultiImageViewer;
    };
    show: typeof showImageViewer;
};
export default _default;
