function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import { withDefaultProps } from '../../utils/with-default-props';
import { renderToContainer } from '../../utils/render-to-container';
import Mask from '../mask';
import { Slide } from './slide';
import { attachPropertiesToComponent } from '../../utils/attach-properties-to-component';
import { Slides } from './slides';
import React, { useState, forwardRef, useImperativeHandle, createRef } from 'react';
import { renderToBody } from '../../utils/render-to-body';
var classPrefix = "am-image-viewer";
var defaultProps = {
  maxZoom: 3,
  getContainer: null,
  visible: false
};
var ImageViewer = withDefaultProps(defaultProps)(function (props) {
  var node = /*#__PURE__*/React.createElement(Mask, {
    visible: props.visible,
    disableBodyScroll: false,
    opacity: 'dark',
    afterClose: props.afterClose
  }, /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-content"
  }, props.image && /*#__PURE__*/React.createElement(Slide, {
    image: props.image,
    onTap: function onTap() {
      props.onClose == null ? void 0 : props.onClose();
    },
    maxZoom: props.maxZoom
  })));
  return renderToContainer(props.getContainer, node);
});

var multiDefaultProps = _extends({}, defaultProps, {
  defaultIndex: 0
});

var MultiImageViewer = withDefaultProps(multiDefaultProps)(function (props) {
  var node = /*#__PURE__*/React.createElement(Mask, {
    visible: props.visible,
    disableBodyScroll: false,
    opacity: 'dark',
    afterClose: props.afterClose
  }, /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-content"
  }, props.images && /*#__PURE__*/React.createElement(Slides, {
    defaultIndex: props.defaultIndex,
    onIndexChange: props.onIndexChange,
    images: props.images,
    onTap: function onTap() {
      props.onClose == null ? void 0 : props.onClose();
    },
    maxZoom: props.maxZoom
  })));
  return renderToContainer(props.getContainer, node);
});

function showImageViewer(props) {
  var Wrapper = /*#__PURE__*/forwardRef(function (_, ref) {
    var _useState = useState(true),
        visible = _useState[0],
        setVisible = _useState[1];

    useImperativeHandle(ref, function () {
      return {
        close: function close() {
          setVisible(false);
        }
      };
    });
    return /*#__PURE__*/React.createElement(ImageViewer, Object.assign({}, props, {
      visible: visible,
      onClose: function onClose() {
        props.onClose == null ? void 0 : props.onClose();
        setVisible(false);
      },
      afterClose: function afterClose() {
        props.afterClose == null ? void 0 : props.afterClose();
        unmount();
      }
    }));
  });
  var ref = /*#__PURE__*/createRef();
  var unmount = renderToBody( /*#__PURE__*/React.createElement(Wrapper, {
    ref: ref
  }));
  return {
    close: function close() {
      var _ref$current;

      (_ref$current = ref.current) == null ? void 0 : _ref$current.close();
    }
  };
}

function showMultiImageViewer(props) {
  var Wrapper = /*#__PURE__*/forwardRef(function (_, ref) {
    var _useState2 = useState(true),
        visible = _useState2[0],
        setVisible = _useState2[1];

    useImperativeHandle(ref, function () {
      return {
        close: function close() {
          setVisible(false);
        }
      };
    });
    return /*#__PURE__*/React.createElement(MultiImageViewer, Object.assign({}, props, {
      visible: visible,
      onClose: function onClose() {
        props.onClose == null ? void 0 : props.onClose();
        setVisible(false);
      },
      afterClose: function afterClose() {
        props.afterClose == null ? void 0 : props.afterClose();
        unmount();
      }
    }));
  });
  var ref = /*#__PURE__*/createRef();
  var unmount = renderToBody( /*#__PURE__*/React.createElement(Wrapper, {
    ref: ref
  }));
  return {
    close: function close() {
      var _ref$current2;

      (_ref$current2 = ref.current) == null ? void 0 : _ref$current2.close();
    }
  };
}

var Multi = attachPropertiesToComponent(MultiImageViewer, {
  show: showMultiImageViewer
});
export default attachPropertiesToComponent(ImageViewer, {
  Multi: Multi,
  show: showImageViewer
});