var _excluded = ["clearable", "onClear", "className", "style", "defaultValue", "value", "onChange"];

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useState, forwardRef, useImperativeHandle, useRef } from 'react';
import classNames from 'classnames';
import { useControllableValue } from 'ahooks';
import { CloseCircleFilled } from '@ant-design/icons';
var classPrefix = "am-input";
var Input = /*#__PURE__*/forwardRef(function (props, ref) {
  var clearable = props.clearable,
      onClear = props.onClear,
      className = props.className,
      style = props.style,
      outerDefaultValue = props.defaultValue,
      outerValue = props.value,
      outerOnChange = props.onChange,
      inputProps = _objectWithoutPropertiesLoose(props, _excluded);

  var _useControllableValue = useControllableValue(props, {
    defaultValue: ''
  }),
      value = _useControllableValue[0],
      setValue = _useControllableValue[1];

  var _useState = useState(false),
      hasFocus = _useState[0],
      setHasFocus = _useState[1];

  var nativeInputRef = useRef(null);
  useImperativeHandle(ref, function () {
    return {
      clear: function clear() {
        setValue('');
      },
      focus: function focus() {
        var _nativeInputRef$curre;

        (_nativeInputRef$curre = nativeInputRef.current) == null ? void 0 : _nativeInputRef$curre.focus();
      },
      blur: function blur() {
        var _nativeInputRef$curre2;

        (_nativeInputRef$curre2 = nativeInputRef.current) == null ? void 0 : _nativeInputRef$curre2.blur();
      }
    };
  });
  return /*#__PURE__*/React.createElement("div", {
    className: classNames(classPrefix + "-wrapper", className),
    style: style
  }, /*#__PURE__*/React.createElement("input", Object.assign({
    ref: nativeInputRef
  }, inputProps, {
    className: classPrefix,
    value: value,
    onChange: function onChange(e) {
      setValue(e.target.value);
    },
    onFocus: function onFocus(e) {
      setHasFocus(true);
      props.onFocus == null ? void 0 : props.onFocus(e);
    },
    onBlur: function onBlur(e) {
      setHasFocus(false);
      props.onBlur == null ? void 0 : props.onBlur(e);
    }
  })), props.clearable && !!value && hasFocus && /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-clear",
    onMouseDown: function onMouseDown(e) {
      e.preventDefault();
    },
    onClick: function onClick() {
      setValue('');
      props.onClear == null ? void 0 : props.onClear();
    }
  }, /*#__PURE__*/React.createElement(CloseCircleFilled, null)));
});
export default Input;