import React from 'react';
import classNames from 'classnames';
import { RightOutlined } from '@ant-design/icons';
var classPrefix = "am-list";

var ListItem = function ListItem(props) {
  var _props$clickable;

  var clickable = (_props$clickable = props.clickable) != null ? _props$clickable : !!props.onClick;
  var arrow = props.arrow === undefined ? clickable : props.arrow;
  var content = /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-item-content"
  }, props.prefix && /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-item-content-prefix"
  }, props.prefix), /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-item-content-main"
  }, props.title && /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-item-title"
  }, props.title), /*#__PURE__*/React.createElement("div", null, props.children), props.description && /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-item-description"
  }, props.description)), props.extra && /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-item-content-extra"
  }, props.extra), arrow && /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-item-content-arrow"
  }, arrow === true ? /*#__PURE__*/React.createElement(RightOutlined, null) : arrow));
  return /*#__PURE__*/React.createElement(clickable ? 'a' : 'div', {
    className: classNames(classPrefix + "-item", props.className, clickable ? ['am-plain-anchor'] : []),
    style: props.style,
    onClick: props.onClick
  }, content);
};

var List = function List(props) {
  var className = classNames(classPrefix, classPrefix + "-" + props.mode, props.className);
  return /*#__PURE__*/React.createElement("div", {
    className: className,
    style: props.style
  }, /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-inner"
  }, props.children));
};

List.defaultProps = {
  mode: 'default'
};
List.Item = ListItem;
export default List;