import React, { memo } from 'react';
import classNames from 'classnames';
import { withDefaultProps } from '../../utils/with-default-props';
var classPrefix = "am-loading";
var colorRecord = {
  "default": 'var(--color-weak)',
  primary: 'var(--color-primary)',
  white: 'var(--color-white)'
};
var defaultProps = {
  size: 'middle',
  color: 'default'
};
var Loading = withDefaultProps(defaultProps)(function (props) {
  var _colorRecord$props$co;

  var style = {
    '--color': (_colorRecord$props$co = colorRecord[props.color]) != null ? _colorRecord$props$co : props.color
  };
  return /*#__PURE__*/React.createElement("div", {
    style: style,
    className: classNames(classPrefix, classPrefix + "-" + props.size)
  }, /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-dot"
  }), /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-dot"
  }), /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-dot"
  }));
});
export default /*#__PURE__*/memo(Loading);