import React, { ReactNode } from 'react';
import { PopupProps } from '../popup';
import { CascaderProps } from './cascader';
import { ElementProps } from '../../utils/element-props';
export declare type PickerValue = string | null;
export declare type PickerColumnItem = {
    label: string;
    value: string;
};
export declare type PickerColumn = (string | PickerColumnItem)[];
export declare type PickerProps = {
    columns: PickerColumn[] | ((value: PickerValue[]) => PickerColumn[]);
    value?: PickerValue[];
    defaultValue?: PickerValue[];
    onSelect?: (value: PickerValue[]) => void;
    onConfirm?: (value: PickerValue[]) => void;
    onCancel?: () => void;
    onClose?: () => void;
    visible?: boolean;
    confirmText?: string;
    cancelText?: string;
    children?: (items: (PickerColumnItem | null)[]) => ReactNode;
} & Pick<PopupProps, 'getContainer' | 'afterShow' | 'afterClose'> & ElementProps;
declare function prompt(props: Omit<PickerProps, 'value' | 'visible' | 'children'>): Promise<(string | null)[] | null>;
declare function promptCascader(props: Omit<CascaderProps, 'value' | 'visible' | 'children'>): Promise<(string | null)[] | null>;
declare const _default: React.FC<PickerProps> & {
    Cascader: React.FC<CascaderProps> & {
        prompt: typeof promptCascader;
    };
    prompt: typeof prompt;
};
export default _default;
