import React from 'react';
import type { TooltipProps } from 'rc-tooltip/lib/Tooltip';
export declare type Action = {
    text: React.ReactNode;
    icon?: React.ReactNode;
    disabled?: boolean;
    key?: string;
    [key: string]: any;
};
declare type PopoverRef = {
    show: () => void;
    hide: () => void;
    visible: boolean;
};
declare const _default: React.ForwardRefExoticComponent<{
    getContainer?: (() => HTMLElement) | undefined;
    destroyOnHide?: boolean | undefined;
    children: React.ReactElement<any, string | ((props: any) => React.ReactElement<any, any> | null) | (new (props: any) => React.Component<any, any, any>)>;
    mode?: "dark" | "light" | undefined;
} & Pick<TooltipProps, "visible" | "zIndex" | "align" | "defaultVisible" | "placement" | "onVisibleChange" | "overlayStyle" | "overlayClassName"> & {
    content: React.ReactNode;
} & React.RefAttributes<PopoverRef>> & {
    Menu: <T extends Action = Action>(props: {
        getContainer?: (() => HTMLElement) | undefined;
        destroyOnHide?: boolean | undefined;
        children: React.ReactElement<any, string | ((props: any) => React.ReactElement<any, any> | null) | (new (props: any) => React.Component<any, any, any>)>;
        mode?: "dark" | "light" | undefined;
    } & Pick<TooltipProps, "visible" | "zIndex" | "align" | "defaultVisible" | "placement" | "onVisibleChange" | "overlayStyle" | "overlayClassName"> & {
        actions: T[];
        onSelect?: ((text: T) => void) | undefined;
    } & {
        ref?: ((instance: PopoverRef | null) => void) | React.RefObject<PopoverRef> | null | undefined;
    }) => React.ReactElement<any, string | ((props: any) => React.ReactElement<any, any> | null) | (new (props: any) => React.Component<any, any, any>)>;
};
export default _default;
