import classNames from 'classnames';
import React from 'react';
import { convertPx } from '../../utils/convert-px';
import { withDefaultProps } from '../../utils/with-default-props';
var classPrefix = "am-progress-bar";
var ProgressBar = withDefaultProps({
  percent: 0,
  strokeColor: '#1677FF'
})(function (props) {
  var strokeWidth = props.strokeWidth;

  if (strokeWidth === undefined) {
    strokeWidth = convertPx(3);
  }

  var trailStyle = {
    height: strokeWidth + "px",
    borderRadius: strokeWidth / 2 + "px",
    background: '#e5e5e5'
  };
  var pathStyle = {
    height: strokeWidth + "px",
    borderRadius: strokeWidth / 2 + "px",
    width: props.percent + "%",
    background: props.strokeColor,
    transition: 'width 0.3s'
  };
  return /*#__PURE__*/React.createElement("div", {
    className: classNames(classPrefix, props.className),
    style: props.style
  }, /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-trail",
    style: trailStyle
  }, /*#__PURE__*/React.createElement("div", {
    className: classNames(classPrefix + "-path"),
    style: pathStyle
  })));
});
export default ProgressBar;