import React from 'react';
import classNames from 'classnames';
import { withDefaultProps } from '../../utils/with-default-props';
import { StarFilled } from '@ant-design/icons';
import { useControllableValue } from 'ahooks';
var classPrefix = "am-rate";
var defaultProps = {
  count: 5,
  allowHalf: false,
  character: /*#__PURE__*/React.createElement(StarFilled, null),
  defaultValue: 0,
  readonly: false,
  allowClear: true
};
var Rate = withDefaultProps(defaultProps)(function (props) {
  var _useControllableValue = useControllableValue(props),
      value = _useControllableValue[0],
      setValue = _useControllableValue[1];

  var starList = Array(props.count).fill(null);

  function renderStar(v, half) {
    var _classNames;

    return /*#__PURE__*/React.createElement("div", {
      className: classNames(classPrefix + "-star", (_classNames = {}, _classNames[classPrefix + "-star-active"] = value >= v, _classNames[classPrefix + "-star-half"] = half, _classNames[classPrefix + "-star-readonly"] = props.readonly, _classNames)),
      onClick: function onClick() {
        if (props.readonly) return;

        if (props.allowClear && value === v) {
          setValue(0);
        } else {
          setValue(v);
        }
      }
    }, props.character);
  }

  return /*#__PURE__*/React.createElement("div", {
    style: props.style,
    className: classNames(classPrefix, props.className)
  }, starList.map(function (_, i) {
    return /*#__PURE__*/React.createElement("div", {
      key: i,
      className: classNames(classPrefix + "-box")
    }, props.allowHalf && renderStar(i + 0.5, true), renderStar(i + 1, false));
  }));
});
export default Rate;