import React from 'react';
import classNames from 'classnames';
import { CheckCircleFilled, CloseCircleFilled, InfoCircleFilled, ClockCircleFilled, ExclamationCircleFilled } from '@ant-design/icons';
var classPrefix = "am-result";
var ICONS = {
  success: CheckCircleFilled,
  error: CloseCircleFilled,
  info: InfoCircleFilled,
  waiting: ClockCircleFilled,
  warning: ExclamationCircleFilled
};

var Result = function Result(props) {
  var className = props.className,
      style = props.style,
      status = props.status,
      title = props.title,
      description = props.description;
  var ResultIcon = ICONS[status];
  return /*#__PURE__*/React.createElement("div", {
    className: classNames(classPrefix, classPrefix + "-" + status, className),
    style: style
  }, /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-icon"
  }, /*#__PURE__*/React.createElement(ResultIcon, null)), /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-title"
  }, title), description ? /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-description"
  }, description) : null);
};

Result.defaultProps = {
  description: ''
};
export default Result;