import React, { useState, useRef } from 'react';
import classNames from 'classnames';
import Input from '../input';
import { withDefaultProps } from '../../utils/with-default-props';
import { SearchOutlined } from '@ant-design/icons';
import { useControllableValue } from 'ahooks';
var classPrefix = "am-search";
var defaultProps = {
  clearable: true,
  showCancelButton: false
};
var Search = withDefaultProps(defaultProps)(function (props) {
  var _classNames;

  var _useControllableValue = useControllableValue(props, {
    defaultValue: ''
  }),
      value = _useControllableValue[0],
      setValue = _useControllableValue[1];

  var _useState = useState(false),
      hasFocus = _useState[0],
      setHasFocus = _useState[1];

  var inputRef = useRef(null);
  return /*#__PURE__*/React.createElement("div", {
    className: classNames(classPrefix, props.className, (_classNames = {}, _classNames[classPrefix + "-active"] = hasFocus, _classNames)),
    style: props.style
  }, /*#__PURE__*/React.createElement("form", {
    className: classPrefix + "-input-box",
    action: '/',
    onSubmit: function onSubmit(e) {
      var _inputRef$current;

      e.preventDefault();
      e.stopPropagation();
      (_inputRef$current = inputRef.current) == null ? void 0 : _inputRef$current.blur();
      props.onSearch == null ? void 0 : props.onSearch(value);
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-input-box-icon"
  }, /*#__PURE__*/React.createElement(SearchOutlined, null)), /*#__PURE__*/React.createElement(Input, {
    ref: inputRef,
    className: classPrefix + "-input",
    value: value,
    onChange: setValue,
    maxLength: props.maxLength,
    placeholder: props.placeholder,
    clearable: props.clearable,
    onFocus: function onFocus() {
      setHasFocus(true);
      props.onFocus == null ? void 0 : props.onFocus();
    },
    onBlur: function onBlur() {
      setHasFocus(false);
      props.onBlur == null ? void 0 : props.onBlur();
    },
    onClear: props.onClear,
    type: 'search'
  })), props.showCancelButton && hasFocus && /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-suffix"
  }, /*#__PURE__*/React.createElement("a", {
    onMouseDown: function onMouseDown(e) {
      e.preventDefault();
    },
    onTouchStart: function onTouchStart(e) {
      e.preventDefault();
    },
    onClick: function onClick() {
      var _inputRef$current2, _inputRef$current3;

      (_inputRef$current2 = inputRef.current) == null ? void 0 : _inputRef$current2.clear();
      (_inputRef$current3 = inputRef.current) == null ? void 0 : _inputRef$current3.blur();
      props.onCancel == null ? void 0 : props.onCancel();
    }
  }, "\u53D6\u6D88")));
});
export default Search;