import { useControllableValue } from 'ahooks';
import classNames from 'classnames';
import React from 'react';
import { withDefaultProps } from '../../utils/with-default-props';
import Space from '../space';
import Grid from '../grid';
import { convertPx } from '../../utils/convert-px';
import selectorCheckMarkImg from '../../assets/selector-check-mark.svg';
var classPrefix = "am-selector";
var Selector = withDefaultProps({
  multiple: false
})(function (props) {
  var _useControllableValue = useControllableValue(props, {
    defaultValue: []
  }),
      value = _useControllableValue[0],
      setValue = _useControllableValue[1];

  var seletorItems = props.options.map(function (option) {
    var _classNames;

    var active = (value || []).includes(option.value);
    var disabled = option.disabled || props.disabled;
    var itemCls = classNames(classPrefix + "-item", (_classNames = {}, _classNames[classPrefix + "-item-active"] = active && !props.multiple, _classNames[classPrefix + "-item-multiple-active"] = active && props.multiple, _classNames[classPrefix + "-item-disabled"] = disabled, _classNames));
    return /*#__PURE__*/React.createElement("div", {
      key: option.value,
      className: itemCls,
      onClick: function onClick() {
        if (disabled) {
          return;
        }

        if (props.multiple) {
          setValue(active ? value.filter(function (v) {
            return v !== option.value;
          }) : [].concat(value, [option.value]));
        } else {
          setValue(active ? [] : [option.value]);
        }
      }
    }, option.label, active && props.multiple && /*#__PURE__*/React.createElement("div", {
      className: classPrefix + "-check-mark-wrapper"
    }, /*#__PURE__*/React.createElement("img", {
      src: selectorCheckMarkImg
    })));
  });
  return /*#__PURE__*/React.createElement("div", {
    className: classNames(classPrefix, props.className),
    style: props.style
  }, !props.columns && /*#__PURE__*/React.createElement(Space, {
    wrap: true
  }, seletorItems), props.columns && /*#__PURE__*/React.createElement(Grid, {
    columns: props.columns,
    gap: convertPx(8)
  }, seletorItems));
});
export default Selector;