import React, { useRef } from 'react';
import { useDrag, subV } from 'react-use-gesture';
var classPrefix = "am-slider";

var Thumb = function Thumb(props) {
  var value = props.value,
      min = props.min,
      max = props.max,
      disabled = props.disabled,
      onDrag = props.onDrag;
  var prevValue = useRef(value);

  var currentPosition = function currentPosition() {
    return {
      left: (value - min) / (max - min) * 100 + "%",
      right: 'auto'
    };
  };

  var bind = useDrag(function (state) {
    var _props$trackRef$curre;

    if (disabled) return;

    if (state.first) {
      prevValue.current = value;
    }

    var _subV = subV(state.xy, state.initial),
        x = _subV[0];

    var sliderOffsetWith = (_props$trackRef$curre = props.trackRef.current) == null ? void 0 : _props$trackRef$curre.offsetWidth;
    if (!sliderOffsetWith) return;
    var diff = x / Math.ceil(sliderOffsetWith) * (max - min);
    onDrag(prevValue.current + diff, state.first, state.last);
  }, {
    axis: 'x'
  });
  return /*#__PURE__*/React.createElement("div", Object.assign({
    className: classPrefix + "-thumb-container",
    style: currentPosition()
  }, bind()), /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-thumb"
  }));
};

export default Thumb;