function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React from 'react';
import classNames from 'classnames';
var classPrefix = "am-space";

var Space = function Space(props) {
  var _props$style, _classNames;

  var _props$size = props.size,
      size = _props$size === void 0 ? 'small' : _props$size,
      _props$direction = props.direction,
      direction = _props$direction === void 0 ? 'horizontal' : _props$direction;
  var style = (_props$style = props.style) != null ? _props$style : {};
  var sizeStyle;

  if (props.size) {
    var _ref = Array.isArray(size) ? size : [size, size],
        horizontalSize = _ref[0],
        verticalSize = _ref[1];

    sizeStyle = {
      '--vertical-size': verticalSize,
      '--horizontal-size': horizontalSize
    };
  }

  return /*#__PURE__*/React.createElement("div", {
    className: classNames(classPrefix, (_classNames = {}, _classNames[classPrefix + "-wrap"] = props.wrap, _classNames[classPrefix + "-block"] = props.block, _classNames), classPrefix + "-" + direction, props.align && classPrefix + "-align-" + props.align, props.className),
    style: _extends({}, sizeStyle, style)
  }, React.Children.map(props.children, function (child) {
    return /*#__PURE__*/React.createElement("div", {
      className: classPrefix + "-item"
    }, child);
  }));
};

export default Space;