import React from 'react';
import classNames from 'classnames';
import Step from './step';
import { withDefaultProps } from '../../utils/with-default-props';
import { attachPropertiesToComponent } from '../../utils/attach-properties-to-component';
var classPrefix = "am-steps";
var stepClassPrefix = "am-step";
var defaultIcon = /*#__PURE__*/React.createElement("span", {
  className: stepClassPrefix + "-icon-dot"
});
var defaultProps = {
  current: 0,
  direction: 'horizontal'
};
var Steps = withDefaultProps(defaultProps)(function (props) {
  var direction = props.direction,
      current = props.current;
  var classString = classNames(classPrefix, classPrefix + "-" + direction);
  return /*#__PURE__*/React.createElement("div", {
    className: classString
  }, React.Children.map(props.children, function (child, index) {
    var _props$icon;

    if (! /*#__PURE__*/React.isValidElement(child)) {
      return child;
    }

    var props = child.props;
    var status = props.status || 'wait';

    if (index < current) {
      status = props.status || 'finish';
    } else if (index === current) {
      status = props.status || 'process';
    }

    var icon = (_props$icon = props.icon) != null ? _props$icon : defaultIcon;
    return /*#__PURE__*/React.cloneElement(child, {
      status: status,
      icon: icon
    });
  }));
});
export default attachPropertiesToComponent(Steps, {
  Step: Step
});