import { useControllableValue } from 'ahooks';
import classNames from 'classnames';
import React from 'react';
import SpinIcon from '../../assets/spin.svg';
var classPrefix = "am-switch";

var Switch = function Switch(props) {
  var _classNames;

  var disabled = props.disabled || props.loading || false;

  var _useControllableValue = useControllableValue(props, {
    valuePropName: 'checked',
    defaultValuePropName: 'defaultChecked',
    defaultValue: false
  }),
      checked = _useControllableValue[0],
      setChecked = _useControllableValue[1];

  return /*#__PURE__*/React.createElement("label", {
    className: classNames(classPrefix, (_classNames = {}, _classNames[classPrefix + "-checked"] = checked, _classNames[classPrefix + "-disabled"] = disabled, _classNames), props.className),
    style: props.style
  }, /*#__PURE__*/React.createElement("input", {
    type: 'checkbox',
    checked: checked,
    onChange: function onChange(e) {
      disabled || setChecked(e.target.checked);
    },
    disabled: disabled
  }), /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-checkbox"
  }, /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-handle"
  }, // 禁用状态优先于加载状态
  props.disabled || props.loading && /*#__PURE__*/React.createElement("img", {
    src: SpinIcon,
    className: classPrefix + "-icon"
  }))));
};

export default Switch;