import React from 'react';
import { useControllableValue } from 'ahooks';
import classNames from 'classnames';
var classPrefix = "am-tab-bar";

var TabBarItem = function TabBarItem() {
  return null;
};

var TabBar = function TabBar(props) {
  var firstActiveKey = undefined;
  var items = [];
  React.Children.forEach(props.children, function (child, index) {
    if (! /*#__PURE__*/React.isValidElement(child)) return;
    var key = child.key;
    if (typeof key !== 'string') return;

    if (index === 0) {
      firstActiveKey = key;
    }

    items.push(child);
  });

  var _useControllableValue = useControllableValue(props, {
    valuePropName: 'activeKey',
    defaultValuePropName: 'defaultActiveKey',
    defaultValue: firstActiveKey,
    trigger: 'onChange'
  }),
      activeKey = _useControllableValue[0],
      setActiveKey = _useControllableValue[1];

  return /*#__PURE__*/React.createElement("div", {
    className: classNames(classPrefix, props.className),
    style: props.style
  }, items.map(function (item) {
    var _classNames;

    return /*#__PURE__*/React.createElement("div", {
      key: item.key,
      onClick: function onClick() {
        var key = item.key;
        if (key === undefined || key === null) return;
        setActiveKey(key.toString());
      },
      className: classNames(classPrefix + "-item", item.props.className, (_classNames = {}, _classNames[classPrefix + "-item-active"] = item.key === activeKey, _classNames))
    }, item.props.icon && /*#__PURE__*/React.createElement("div", {
      className: classPrefix + "-item-icon"
    }, item.props.icon), item.props.title && /*#__PURE__*/React.createElement("div", {
      className: classPrefix + "-item-title"
    }, item.props.title), item.props.children);
  }));
};

TabBar.Item = TabBarItem;
export default TabBar;