import React from 'react';
import { useControllableValue } from 'ahooks';
import classNames from 'classnames';
import { getNativeAttributes } from '../../utils/get-native-attributes';
var classPrefix = "am-tabs";

var TabPane = function TabPane() {
  return null;
};

var Tabs = function Tabs(props) {
  var childrenRecord = {};
  var firstActiveKey = undefined;
  var panes = [];
  React.Children.forEach(props.children, function (child, index) {
    if (! /*#__PURE__*/React.isValidElement(child)) return;
    var key = child.key;
    if (typeof key !== 'string') return;

    if (index === 0) {
      firstActiveKey = key;
    }

    childrenRecord[key] = child.props.children;
    panes.push(child);
  });

  var _useControllableValue = useControllableValue(props, {
    valuePropName: 'activeKey',
    defaultValuePropName: 'defaultActiveKey',
    defaultValue: firstActiveKey,
    trigger: 'onChange'
  }),
      activeKey = _useControllableValue[0],
      setActiveKey = _useControllableValue[1];

  return /*#__PURE__*/React.createElement("div", Object.assign({}, getNativeAttributes(props), {
    className: classNames(classPrefix, props.className),
    style: props.style
  }), /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-tab-list"
  }, panes.map(function (pane) {
    var _classNames;

    return /*#__PURE__*/React.createElement("div", Object.assign({
      key: pane.key
    }, getNativeAttributes(pane.props), {
      className: classPrefix + "-tab-wrapper"
    }), /*#__PURE__*/React.createElement("div", {
      onClick: function onClick() {
        var key = pane.key;

        if (key === undefined || key === null) {
          return;
        }

        setActiveKey(key.toString());
      },
      className: classNames(classPrefix + "-tab", (_classNames = {}, _classNames[classPrefix + "-tab-active"] = pane.key === activeKey, _classNames))
    }, pane.props.title));
  })), panes.map(function (pane) {
    if (pane.props.children === undefined) {
      return null;
    }

    if (pane.key === activeKey) {
      return /*#__PURE__*/React.createElement("div", {
        key: pane.key,
        className: classPrefix + "-content"
      }, pane.props.children);
    }

    if (pane.props.forceRender) {
      return /*#__PURE__*/React.createElement("div", {
        key: pane.key,
        style: {
          display: 'none'
        }
      }, pane.props.children);
    }

    return null;
  }));
};

Tabs.TabPane = TabPane;
export default Tabs;