function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React from 'react';
import { mergeProps } from '../../utils/with-default-props';
import classNames from 'classnames';
var classPrefix = "am-tag";
var colorRecord = {
  "default": '#666666',
  primary: '#1677FF'
};
var defaultProps = {
  color: 'default',
  fill: 'solid',
  round: false
};

var Tag = function Tag(p) {
  var _colorRecord$props$co, _classNames;

  var props = mergeProps(defaultProps, p);
  var color = (_colorRecord$props$co = colorRecord[props.color]) != null ? _colorRecord$props$co : props.color;

  var style = _extends({
    '--color': color
  }, props.style);

  return /*#__PURE__*/React.createElement("span", {
    style: style,
    className: classNames(classPrefix, (_classNames = {}, _classNames[classPrefix + "-round"] = props.round, _classNames[classPrefix + "-outline"] = props.fill === 'outline', _classNames), props.className)
  }, props.children);
};

export default Tag;