import React from 'react';
export interface ToastProps {
    /** Toast 完全关闭后的回调 */
    afterClose?: () => void;
    /** Toast 遮罩样式 */
    maskStyle?: React.CSSProperties;
    /** Toast 遮罩类名 */
    maskClassName?: string;
    /** 是否允许背景点击 */
    maskClickable?: boolean;
    /** toast 文本内容 */
    content?: string;
    /** toast 图标 */
    icon?: React.ReactNode;
    /** 提示持续时间，若为 0 则不会自动关闭 */
    duration?: number;
    /** 垂直方向显示位置，默认为 center */
    position?: 'top' | 'bottom' | 'center';
    /** 是否显示 */
    visible?: boolean;
    /** 轻提示弹出时的的父容器 */
    getContainer?: HTMLElement | (() => HTMLElement);
}
declare function show(props: ToastProps): React.Dispatch<React.SetStateAction<ToastProps>>;
declare type ToastPropsWithoutIcon = Omit<ToastProps, 'icon'>;
declare function success(props: ToastPropsWithoutIcon): React.Dispatch<React.SetStateAction<ToastProps>>;
declare function fail(props: ToastPropsWithoutIcon): React.Dispatch<React.SetStateAction<ToastProps>>;
declare function loading(props: ToastPropsWithoutIcon): React.Dispatch<React.SetStateAction<ToastProps>>;
declare function clear(): void;
declare const Toast: {
    show: typeof show;
    success: typeof success;
    fail: typeof fail;
    loading: typeof loading;
    clear: typeof clear;
};
export default Toast;
